// Koka generated module: std/os/dir, koka version: 3.1.3, platform: 64-bit
#include "std_os_dir.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_exn__error kk_os_ensure_dir_error( kk_string_t path, kk_integer_t mode, kk_context_t* ctx ) {
  int m  = kk_integer_clamp32(mode,ctx);
  const int err = kk_os_ensure_dir(path,m,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core_exn__error kk_os_copy_file_error( kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* ctx ) {
  const int err = kk_os_copy_file(from,to,preserve_mtime,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core_exn__error kk_os_list_directory_prim( kk_string_t dir, kk_context_t* ctx ) {
  kk_vector_t contents;
  const int err = kk_os_list_directory(dir,&contents,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_vector_box(contents,ctx),ctx);
}


kk_std_core_exn__exception kk_std_os_dir_prepend(kk_std_core_exn__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x_x319;
  kk_string_t _x_x320;
  kk_string_t _x_x321;
  kk_define_string_literal(, _s_x322, 2, ": ", _ctx)
  _x_x321 = kk_string_dup(_s_x322, _ctx); /*string*/
  kk_string_t _x_x323;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x_x323 = _x; /*string*/
  }
  _x_x320 = kk_std_core_types__lp__plus__plus__rp_(_x_x321, _x_x323, _ctx); /*string*/
  _x_x319 = kk_std_core_types__lp__plus__plus__rp_(pre, _x_x320, _ctx); /*string*/
  kk_std_core_exn__exception_info _x_x324;
  {
    kk_std_core_exn__exception_info _x_0 = exn.info;
    kk_std_core_exn__exception_info_dup(_x_0, _ctx);
    kk_std_core_exn__exception_drop(exn, _ctx);
    _x_x324 = _x_0; /*exception-info*/
  }
  return kk_std_core_exn__new_Exception(_x_x319, _x_x324, _ctx);
}

kk_std_core_exn__error kk_std_os_dir_prim_copy_file(kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* _ctx) { /* (from : string, to : string, preserve-mtime : bool) -> fsys error<()> */ 
  return kk_os_copy_file_error(from,to,preserve_mtime,kk_context());
}
 
// Copy a file.


// lift anonymous function
struct kk_std_os_dir_copy_file_fun326__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun326(kk_function_t _fself, kk_box_t _b_x2, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun326(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun326, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun326(kk_function_t _fself, kk_box_t _b_x2, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x327;
  kk_std_os_path__path _x_x328 = kk_std_os_path__path_unbox(_b_x2, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x327 = kk_std_os_path_string(_x_x328, _ctx); /*string*/
  return kk_string_box(_x_x327);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun332__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun332(kk_function_t _fself, kk_box_t _b_x7, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun332(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun332, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun332(kk_function_t _fself, kk_box_t _b_x7, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x333;
  kk_std_os_path__path _x_x334 = kk_std_os_path__path_unbox(_b_x7, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x333 = kk_std_os_path_string(_x_x334, _ctx); /*string*/
  return kk_string_box(_x_x333);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun338__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun338(kk_function_t _fself, kk_box_t _b_x15, kk_box_t _b_x16, kk_box_t _b_x17, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun338(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun338, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun338(kk_function_t _fself, kk_box_t _b_x15, kk_box_t _b_x16, kk_box_t _b_x17, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_exn__error _x_x339;
  kk_string_t _x_x340 = kk_string_unbox(_b_x15); /*string*/
  kk_string_t _x_x341 = kk_string_unbox(_b_x16); /*string*/
  bool _x_x342 = kk_bool_unbox(_b_x17); /*bool*/
  _x_x339 = kk_std_os_dir_prim_copy_file(_x_x340, _x_x341, _x_x342, _ctx); /*error<()>*/
  return kk_std_core_exn__error_box(_x_x339, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun350__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun350(kk_function_t _fself, kk_box_t _b_x20, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun350(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun350, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun350(kk_function_t _fself, kk_box_t _b_x20, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x351;
  kk_string_t _x_x352;
  kk_std_os_path__path _x_x353 = kk_std_os_path__path_unbox(_b_x20, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x352 = kk_std_os_path_string(_x_x353, _ctx); /*string*/
  _x_x351 = kk_std_core_show_string_fs_show(_x_x352, _ctx); /*string*/
  return kk_string_box(_x_x351);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun359__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun359(kk_function_t _fself, kk_box_t _b_x23, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun359(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun359, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun359(kk_function_t _fself, kk_box_t _b_x23, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_os_path__path p_0_51 = kk_std_os_path__path_unbox(_b_x23, KK_OWNED, _ctx); /*std/os/path/path*/;
  kk_string_t _x_x360;
  kk_string_t _x_x361 = kk_std_os_path_string(p_0_51, _ctx); /*string*/
  _x_x360 = kk_std_core_show_string_fs_show(_x_x361, _ctx); /*string*/
  return kk_string_box(_x_x360);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun363__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun363(kk_function_t _fself, kk_box_t _b_x31, kk_box_t _b_x32, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun363(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun363, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun363(kk_function_t _fself, kk_box_t _b_x31, kk_box_t _b_x32, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_exn__exception _x_x364;
  kk_string_t _x_x365;
  kk_string_t _x_x366 = kk_string_unbox(_b_x32); /*string*/
  kk_string_t _x_x367;
  kk_string_t _x_x368;
  kk_define_string_literal(, _s_x369, 2, ": ", _ctx)
  _x_x368 = kk_string_dup(_s_x369, _ctx); /*string*/
  kk_string_t _x_x370;
  kk_std_core_exn__exception _match_x316;
  kk_box_t _x_x371 = kk_box_dup(_b_x31, _ctx); /*9661*/
  _match_x316 = kk_std_core_exn__exception_unbox(_x_x371, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x = _match_x316.message;
    kk_string_dup(_x, _ctx);
    kk_std_core_exn__exception_drop(_match_x316, _ctx);
    _x_x370 = _x; /*string*/
  }
  _x_x367 = kk_std_core_types__lp__plus__plus__rp_(_x_x368, _x_x370, _ctx); /*string*/
  _x_x365 = kk_std_core_types__lp__plus__plus__rp_(_x_x366, _x_x367, _ctx); /*string*/
  kk_std_core_exn__exception_info _x_x372;
  kk_std_core_exn__exception _match_x315 = kk_std_core_exn__exception_unbox(_b_x31, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core_exn__exception_info _x_0 = _match_x315.info;
    kk_std_core_exn__exception_info_dup(_x_0, _ctx);
    kk_std_core_exn__exception_drop(_match_x315, _ctx);
    _x_x372 = _x_0; /*exception-info*/
  }
  _x_x364 = kk_std_core_exn__new_Exception(_x_x365, _x_x372, _ctx); /*exception*/
  return kk_std_core_exn__exception_box(_x_x364, _ctx);
}

kk_unit_t kk_std_os_dir_copy_file(kk_std_os_path__path from, kk_std_os_path__path to, kk_std_core_types__optional preserve_mtime, kk_context_t* _ctx) { /* (from : std/os/path/path, to : std/os/path/path, preserve-mtime : ? bool) -> <exn,fsys> () */ 
  kk_string_t _x_x1_10043;
  kk_box_t _x_x325;
  kk_box_t _x_x329;
  kk_std_os_path__path _x_x330 = kk_std_os_path__path_dup(from, _ctx); /*std/os/path/path*/
  _x_x329 = kk_std_os_path__path_box(_x_x330, _ctx); /*9585*/
  _x_x325 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun326(_ctx), _x_x329, _ctx); /*9586*/
  _x_x1_10043 = kk_string_unbox(_x_x325); /*string*/
  kk_string_t _x_x2_10044;
  kk_box_t _x_x331;
  kk_box_t _x_x335;
  kk_std_os_path__path _x_x336 = kk_std_os_path__path_dup(to, _ctx); /*std/os/path/path*/
  _x_x335 = kk_std_os_path__path_box(_x_x336, _ctx); /*9585*/
  _x_x331 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun332(_ctx), _x_x335, _ctx); /*9586*/
  _x_x2_10044 = kk_string_unbox(_x_x331); /*string*/
  kk_std_core_exn__error _match_x312;
  kk_box_t _x_x337;
  kk_box_t _x_x343;
  bool _x_x344;
  if (kk_std_core_types__is_Optional(preserve_mtime, _ctx)) {
    kk_box_t _box_x10 = preserve_mtime._cons._Optional.value;
    bool _uniq_preserve_mtime_93 = kk_bool_unbox(_box_x10);
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x_x344 = _uniq_preserve_mtime_93; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x_x344 = true; /*bool*/
  }
  _x_x343 = kk_bool_box(_x_x344); /*9752*/
  _x_x337 = kk_std_core_hnd__open_none3(kk_std_os_dir_new_copy_file_fun338(_ctx), kk_string_box(_x_x1_10043), kk_string_box(_x_x2_10044), _x_x343, _ctx); /*9753*/
  _match_x312 = kk_std_core_exn__error_unbox(_x_x337, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core_exn__is_Error(_match_x312, _ctx)) {
    kk_std_core_exn__exception exn = _match_x312._cons.Error.exception;
    kk_std_core_exn__exception_dup(exn, _ctx);
    kk_std_core_exn__error_drop(_match_x312, _ctx);
    kk_string_t _x_x2_0_10049;
    kk_string_t _x_x345;
    kk_define_string_literal(, _s_x346, 15, "unable to copy ", _ctx)
    _x_x345 = kk_string_dup(_s_x346, _ctx); /*string*/
    kk_string_t _x_x347;
    kk_string_t _x_x348;
    kk_box_t _x_x349 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun350(_ctx), kk_std_os_path__path_box(from, _ctx), _ctx); /*9586*/
    _x_x348 = kk_string_unbox(_x_x349); /*string*/
    kk_string_t _x_x354;
    kk_string_t _x_x355;
    kk_define_string_literal(, _s_x356, 4, " to ", _ctx)
    _x_x355 = kk_string_dup(_s_x356, _ctx); /*string*/
    kk_string_t _x_x357;
    kk_box_t _x_x358 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun359(_ctx), kk_std_os_path__path_box(to, _ctx), _ctx); /*9586*/
    _x_x357 = kk_string_unbox(_x_x358); /*string*/
    _x_x354 = kk_std_core_types__lp__plus__plus__rp_(_x_x355, _x_x357, _ctx); /*string*/
    _x_x347 = kk_std_core_types__lp__plus__plus__rp_(_x_x348, _x_x354, _ctx); /*string*/
    _x_x2_0_10049 = kk_std_core_types__lp__plus__plus__rp_(_x_x345, _x_x347, _ctx); /*string*/
    kk_std_core_exn__exception exn_0_10002;
    kk_box_t _x_x362 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_file_fun363(_ctx), kk_std_core_exn__exception_box(exn, _ctx), kk_string_box(_x_x2_0_10049), _ctx); /*9663*/
    exn_0_10002 = kk_std_core_exn__exception_unbox(_x_x362, KK_OWNED, _ctx); /*exception*/
    kk_std_core_hnd__ev ev_10071 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t _x_x373;
    {
      struct kk_std_core_hnd_Ev* _con_x374 = kk_std_core_hnd__as_Ev(ev_10071, _ctx);
      kk_box_t _box_x38 = _con_x374->hnd;
      int32_t m = _con_x374->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x38, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x313;
      kk_std_core_hnd__clause1 _brw_x314 = kk_std_core_exn_throw_exn_fs__select(h, _ctx); /*hnd/clause1<exception,274,exn,275,276>*/;
      kk_datatype_ptr_dropn(h, (KK_I32(2)), _ctx);
      _match_x313 = _brw_x314; /*hnd/clause1<exception,274,exn,275,276>*/
      {
        kk_function_t _fun_unbox_x42 = _match_x313.clause;
        _x_x373 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x42, (_fun_unbox_x42, m, ev_10071, kk_std_core_exn__exception_box(exn_0_10002, _ctx), _ctx), _ctx); /*46*/
      }
    }
    kk_unit_unbox(_x_x373); return kk_Unit;
  }
  {
    kk_std_os_path__path_drop(to, _ctx);
    kk_std_os_path__path_drop(from, _ctx);
    kk_std_core_exn__error_drop(_match_x312, _ctx);
    kk_Unit; return kk_Unit;
  }
}

kk_std_core_exn__error kk_std_os_dir_ensure_dir_err(kk_string_t path, kk_integer_t mode, kk_context_t* _ctx) { /* (path : string, mode : int) -> fsys error<()> */ 
  return kk_os_ensure_dir_error(path,mode,kk_context());
}
 
// Ensure a directory path exists


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun376__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun376(kk_function_t _fself, kk_box_t _b_x54, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun376(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun376, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun376(kk_function_t _fself, kk_box_t _b_x54, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x377;
  kk_std_os_path__path _x_x378 = kk_std_os_path__path_unbox(_b_x54, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x377 = kk_std_os_path_string(_x_x378, _ctx); /*string*/
  return kk_string_box(_x_x377);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun382__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun382(kk_function_t _fself, kk_box_t _b_x60, kk_box_t _b_x61, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun382(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun382, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun382(kk_function_t _fself, kk_box_t _b_x60, kk_box_t _b_x61, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_exn__error _x_x383;
  kk_string_t _x_x384 = kk_string_unbox(_b_x60); /*string*/
  kk_integer_t _x_x385 = kk_integer_unbox(_b_x61, _ctx); /*int*/
  _x_x383 = kk_std_os_dir_ensure_dir_err(_x_x384, _x_x385, _ctx); /*error<()>*/
  return kk_std_core_exn__error_box(_x_x383, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun390__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun390(kk_function_t _fself, kk_box_t _b_x64, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun390(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun390, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun390(kk_function_t _fself, kk_box_t _b_x64, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x391;
  kk_string_t _x_x392;
  kk_std_os_path__path _x_x393 = kk_std_os_path__path_unbox(_b_x64, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x392 = kk_std_os_path_string(_x_x393, _ctx); /*string*/
  _x_x391 = kk_std_core_show_string_fs_show(_x_x392, _ctx); /*string*/
  return kk_string_box(_x_x391);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun395__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun395(kk_function_t _fself, kk_box_t _b_x71, kk_box_t _b_x72, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun395(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun395, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun395(kk_function_t _fself, kk_box_t _b_x71, kk_box_t _b_x72, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_exn__exception _x_x396;
  kk_string_t _x_x397;
  kk_string_t _x_x398 = kk_string_unbox(_b_x72); /*string*/
  kk_string_t _x_x399;
  kk_string_t _x_x400;
  kk_define_string_literal(, _s_x401, 2, ": ", _ctx)
  _x_x400 = kk_string_dup(_s_x401, _ctx); /*string*/
  kk_string_t _x_x402;
  kk_std_core_exn__exception _match_x311;
  kk_box_t _x_x403 = kk_box_dup(_b_x71, _ctx); /*9661*/
  _match_x311 = kk_std_core_exn__exception_unbox(_x_x403, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x = _match_x311.message;
    kk_string_dup(_x, _ctx);
    kk_std_core_exn__exception_drop(_match_x311, _ctx);
    _x_x402 = _x; /*string*/
  }
  _x_x399 = kk_std_core_types__lp__plus__plus__rp_(_x_x400, _x_x402, _ctx); /*string*/
  _x_x397 = kk_std_core_types__lp__plus__plus__rp_(_x_x398, _x_x399, _ctx); /*string*/
  kk_std_core_exn__exception_info _x_x404;
  kk_std_core_exn__exception _match_x310 = kk_std_core_exn__exception_unbox(_b_x71, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core_exn__exception_info _x_0 = _match_x310.info;
    kk_std_core_exn__exception_info_dup(_x_0, _ctx);
    kk_std_core_exn__exception_drop(_match_x310, _ctx);
    _x_x404 = _x_0; /*exception-info*/
  }
  _x_x396 = kk_std_core_exn__new_Exception(_x_x397, _x_x404, _ctx); /*exception*/
  return kk_std_core_exn__exception_box(_x_x396, _ctx);
}

kk_unit_t kk_std_os_dir_ensure_dir(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_string_t _x_x1_10052;
  kk_box_t _x_x375;
  kk_box_t _x_x379;
  kk_std_os_path__path _x_x380 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x_x379 = kk_std_os_path__path_box(_x_x380, _ctx); /*9585*/
  _x_x375 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun376(_ctx), _x_x379, _ctx); /*9586*/
  _x_x1_10052 = kk_string_unbox(_x_x375); /*string*/
  kk_std_core_exn__error _match_x307;
  kk_box_t _x_x381 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_ensure_dir_fun382(_ctx), kk_string_box(_x_x1_10052), kk_integer_box(kk_integer_from_small(-1), _ctx), _ctx); /*9663*/
  _match_x307 = kk_std_core_exn__error_unbox(_x_x381, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core_exn__is_Error(_match_x307, _ctx)) {
    kk_std_core_exn__exception exn = _match_x307._cons.Error.exception;
    kk_std_core_exn__exception_dup(exn, _ctx);
    kk_std_core_exn__error_drop(_match_x307, _ctx);
    kk_string_t _x_x2_0_10056;
    kk_string_t _x_x386;
    kk_define_string_literal(, _s_x387, 27, "unable to create directory ", _ctx)
    _x_x386 = kk_string_dup(_s_x387, _ctx); /*string*/
    kk_string_t _x_x388;
    kk_box_t _x_x389 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun390(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*9586*/
    _x_x388 = kk_string_unbox(_x_x389); /*string*/
    _x_x2_0_10056 = kk_std_core_types__lp__plus__plus__rp_(_x_x386, _x_x388, _ctx); /*string*/
    kk_std_core_exn__exception exn_0_10005;
    kk_box_t _x_x394 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_ensure_dir_fun395(_ctx), kk_std_core_exn__exception_box(exn, _ctx), kk_string_box(_x_x2_0_10056), _ctx); /*9663*/
    exn_0_10005 = kk_std_core_exn__exception_unbox(_x_x394, KK_OWNED, _ctx); /*exception*/
    kk_std_core_hnd__ev ev_10074 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t _x_x405;
    {
      struct kk_std_core_hnd_Ev* _con_x406 = kk_std_core_hnd__as_Ev(ev_10074, _ctx);
      kk_box_t _box_x78 = _con_x406->hnd;
      int32_t m = _con_x406->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x78, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x308;
      kk_std_core_hnd__clause1 _brw_x309 = kk_std_core_exn_throw_exn_fs__select(h, _ctx); /*hnd/clause1<exception,274,exn,275,276>*/;
      kk_datatype_ptr_dropn(h, (KK_I32(2)), _ctx);
      _match_x308 = _brw_x309; /*hnd/clause1<exception,274,exn,275,276>*/
      {
        kk_function_t _fun_unbox_x82 = _match_x308.clause;
        _x_x405 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x82, (_fun_unbox_x82, m, ev_10074, kk_std_core_exn__exception_box(exn_0_10005, _ctx), _ctx), _ctx); /*46*/
      }
    }
    kk_unit_unbox(_x_x405); return kk_Unit;
  }
  {
    kk_box_t _box_x86 = _match_x307._cons.Ok.result;
    kk_unit_t _pat_3_0 = kk_unit_unbox(_box_x86);
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core_exn__error_drop(_match_x307, _ctx);
    kk_Unit; return kk_Unit;
  }
}

bool kk_std_os_dir_prim_is_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys bool */ 
  return kk_os_is_directory(dir,kk_context());
}

kk_std_core_exn__error kk_std_os_dir_prim_list_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys error<vector<string>> */ 
  return kk_os_list_directory_prim(dir,kk_context());
}
 
// List directory contents (excluding `.` and `..`).
// Returns a list of full paths (not just the names in the directory).


// lift anonymous function
struct kk_std_os_dir_list_directory_fun410__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir;
};
static kk_box_t kk_std_os_dir_list_directory_fun410(kk_function_t _fself, kk_box_t _b_x93, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_fun410(kk_std_os_path__path dir, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun410__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_fun410__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_list_directory_fun410, kk_context());
  _self->dir = dir;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_list_directory_fun410(kk_function_t _fself, kk_box_t _b_x93, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun410__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_fun410__t*, _fself, _ctx);
  kk_std_os_path__path dir = _self->dir; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir, _ctx);}, {}, _ctx)
  kk_string_t name_96 = kk_string_unbox(_b_x93); /*string*/;
  kk_std_os_path__path _x_x411;
  kk_std_os_path__path _x_x412 = kk_std_os_path_path(name_96, _ctx); /*std/os/path/path*/
  _x_x411 = kk_std_os_path__lp__fs__rp_(dir, _x_x412, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x411, _ctx);
}

kk_std_core_types__list kk_std_os_dir_list_directory(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> fsys list<std/os/path/path> */ 
  kk_std_core_exn__error _match_x304;
  kk_string_t _x_x408;
  kk_std_os_path__path _x_x409 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x_x408 = kk_std_os_path_string(_x_x409, _ctx); /*string*/
  _match_x304 = kk_std_os_dir_prim_list_dir(_x_x408, _ctx); /*error<vector<string>>*/
  if (kk_std_core_exn__is_Error(_match_x304, _ctx)) {
    kk_std_core_exn__exception _pat_0 = _match_x304._cons.Error.exception;
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core_exn__error_drop(_match_x304, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_box_t _box_x90 = _match_x304._cons.Ok.result;
    kk_vector_t contents = kk_vector_unbox(_box_x90, _ctx);
    kk_vector_dup(contents, _ctx);
    kk_std_core_exn__error_drop(_match_x304, _ctx);
    kk_std_core_types__list _b_x91_94 = kk_std_core_vector_vlist(contents, kk_std_core_types__new_None(_ctx), _ctx); /*list<string>*/;
    kk_function_t _brw_x305 = kk_std_os_dir_new_list_directory_fun410(dir, _ctx); /*(2105) -> 2107 2106*/;
    kk_std_core_types__list _brw_x306 = kk_std_core_list_map(_b_x91_94, _brw_x305, _ctx); /*list<2106>*/;
    kk_function_drop(_brw_x305, _ctx);
    return _brw_x306;
  }
}
 
// Recursively list all the entries under a directory.


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun414__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_list_directory_recursive_fun414(kk_function_t _fself, kk_box_t _b_x100, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun414(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_list_directory_recursive_fun414, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static bool kk_std_os_dir_list_directory_recursive_fun414(kk_function_t _fself, kk_box_t _b_x100, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_os_path__path _x_x415 = kk_std_os_path__path_unbox(_b_x100, KK_OWNED, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_is_directory(_x_x415, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun416__t {
  struct kk_function_s _base;
  kk_std_core_types__optional max_depth;
};
static kk_std_core_types__list kk_std_os_dir_list_directory_recursive_fun416(kk_function_t _fself, kk_box_t _b_x107, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun416(kk_std_core_types__optional max_depth, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun416__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_recursive_fun416__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_list_directory_recursive_fun416, kk_context());
  _self->max_depth = max_depth;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core_types__list kk_std_os_dir_list_directory_recursive_fun416(kk_function_t _fself, kk_box_t _b_x107, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun416__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_recursive_fun416__t*, _fself, _ctx);
  kk_std_core_types__optional max_depth = _self->max_depth; /* ? int */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(max_depth, _ctx);}, {}, _ctx)
  kk_integer_t _b_x104_110;
  kk_integer_t _x_x417;
  if (kk_std_core_types__is_Optional(max_depth, _ctx)) {
    kk_box_t _box_x103 = max_depth._cons._Optional.value;
    kk_integer_t _uniq_max_depth_436_0 = kk_integer_unbox(_box_x103, _ctx);
    kk_integer_dup(_uniq_max_depth_436_0, _ctx);
    kk_std_core_types__optional_drop(max_depth, _ctx);
    _x_x417 = _uniq_max_depth_436_0; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(max_depth, _ctx);
    _x_x417 = kk_integer_from_small(1000); /*int*/
  }
  _b_x104_110 = kk_integer_add_small_const(_x_x417, -1, _ctx); /*int*/
  kk_std_os_path__path _x_x418 = kk_std_os_path__path_unbox(_b_x107, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_core_types__optional _x_x419 = kk_std_core_types__new_Optional(kk_integer_box(_b_x104_110, _ctx), _ctx); /*? 7*/
  return kk_std_os_dir_list_directory_recursive(_x_x418, _x_x419, _ctx);
}

kk_std_core_types__list kk_std_os_dir_list_directory_recursive(kk_std_os_path__path dir, kk_std_core_types__optional max_depth, kk_context_t* _ctx) { /* (dir : std/os/path/path, max-depth : ? int) -> <div,fsys> list<std/os/path/path> */ 
  bool _match_x301;
  kk_integer_t _brw_x302;
  if (kk_std_core_types__is_Optional(max_depth, _ctx)) {
    kk_box_t _box_x97 = max_depth._cons._Optional.value;
    kk_integer_t _uniq_max_depth_436 = kk_integer_unbox(_box_x97, _ctx);
    kk_integer_dup(_uniq_max_depth_436, _ctx);
    _brw_x302 = _uniq_max_depth_436; /*int*/
  }
  else {
    _brw_x302 = kk_integer_from_small(1000); /*int*/
  }
  bool _brw_x303 = kk_integer_lt_borrow(_brw_x302,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_x302, _ctx);
  _match_x301 = _brw_x303; /*bool*/
  if (_match_x301) {
    kk_std_core_types__optional_drop(max_depth, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_std_core_types__list all = kk_std_os_dir_list_directory(dir, _ctx); /*list<std/os/path/path>*/;
    kk_std_core_types__list dirs;
    kk_std_core_types__list _x_x413 = kk_std_core_types__list_dup(all, _ctx); /*list<std/os/path/path>*/
    dirs = kk_std_core_list_filter(_x_x413, kk_std_os_dir_new_list_directory_recursive_fun414(_ctx), _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__list ys_10010 = kk_std_core_list_flatmap(dirs, kk_std_os_dir_new_list_directory_recursive_fun416(max_depth, _ctx), _ctx); /*list<std/os/path/path>*/;
    return kk_std_core_list_append(all, ys_10010, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10068_fun420__t {
  struct kk_function_s _base;
  kk_std_os_path__path to;
};
static kk_unit_t kk_std_os_dir__mlift_copy_directory_10068_fun420(kk_function_t _fself, kk_box_t _b_x128, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10068_fun420(kk_std_os_path__path to, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10068_fun420__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10068_fun420__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10068_fun420, kk_context());
  _self->to = to;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10068_fun422__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10068_fun422(kk_function_t _fself, kk_box_t _b_x117, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10068_fun422(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10068_fun422, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10068_fun422(kk_function_t _fself, kk_box_t _b_x117, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _b_x112_113;
  kk_std_core_types__list _x_x423;
  kk_std_os_path__path _match_x300;
  kk_box_t _x_x424 = kk_box_dup(_b_x117, _ctx); /*9585*/
  _match_x300 = kk_std_os_path__path_unbox(_x_x424, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1_0 = _match_x300.parts;
    kk_std_core_types__list_dup(_x_1_0, _ctx);
    kk_std_os_path__path_drop(_match_x300, _ctx);
    _x_x423 = _x_1_0; /*list<string>*/
  }
  _b_x112_113 = kk_std_core_list_take(_x_x423, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x425;
  kk_string_t _x_x426 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x428;
  kk_std_core_types__optional _match_x298 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x112_113, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x298, _ctx)) {
    kk_box_t _box_x114 = _match_x298._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_133_0 = kk_std_core_types__list_unbox(_box_x114, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_133_0, _ctx);
    kk_std_core_types__optional_drop(_match_x298, _ctx);
    kk_box_drop(_b_x117, _ctx);
    _x_x428 = _uniq_parts_133_0; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x298, _ctx);
    kk_std_os_path__path _match_x299 = kk_std_os_path__path_unbox(_b_x117, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0_0 = _match_x299.parts;
      kk_std_core_types__list_dup(_x_0_0, _ctx);
      kk_std_os_path__path_drop(_match_x299, _ctx);
      _x_x428 = _x_0_0; /*list<string>*/
    }
  }
  _x_x425 = kk_std_os_path__new_Path(_x_x426, _x_x428, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x425, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10068_fun433__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10068_fun433(kk_function_t _fself, kk_box_t _b_x124, kk_box_t _b_x125, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10068_fun433(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10068_fun433, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10068_fun433(kk_function_t _fself, kk_box_t _b_x124, kk_box_t _b_x125, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_os_path__path _x_x434;
  kk_std_os_path__path _x_x435 = kk_std_os_path__path_unbox(_b_x124, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x436 = kk_std_os_path__path_unbox(_b_x125, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x434 = kk_std_os_path__lp__fs__rp_(_x_x435, _x_x436, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x434, _ctx);
}
static kk_unit_t kk_std_os_dir__mlift_copy_directory_10068_fun420(kk_function_t _fself, kk_box_t _b_x128, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10068_fun420__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10068_fun420__t*, _fself, _ctx);
  kk_std_os_path__path to = _self->to; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x_x2_0_10063;
  kk_box_t _x_x421;
  kk_box_t _x_x429 = kk_box_dup(_b_x128, _ctx); /*2872*/
  _x_x421 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10068_fun422(_ctx), _x_x429, _ctx); /*9586*/
  _x_x2_0_10063 = kk_std_os_path__path_unbox(_x_x421, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x430 = kk_std_os_path__path_unbox(_b_x128, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x431;
  kk_box_t _x_x432 = kk_std_core_hnd__open_none2(kk_std_os_dir__new_mlift_copy_directory_10068_fun433(_ctx), kk_std_os_path__path_box(to, _ctx), kk_std_os_path__path_box(_x_x2_0_10063, _ctx), _ctx); /*9663*/
  _x_x431 = kk_std_os_path__path_unbox(_x_x432, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_directory(_x_x430, _x_x431, _ctx); return kk_Unit;
}

kk_unit_t kk_std_os_dir__mlift_copy_directory_10068(kk_std_core_types__list dirs, kk_std_os_path__path to, kk_unit_t wild___0, kk_context_t* _ctx) { /* (dirs : list<std/os/path/path>, to : std/os/path/path, wild_@0 : ()) -> <exn,fsys,div> () */ 
  kk_std_core_list_foreach(dirs, kk_std_os_dir__new_mlift_copy_directory_10068_fun420(to, _ctx), _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10069_fun438__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_0;
};
static kk_unit_t kk_std_os_dir__mlift_copy_directory_10069_fun438(kk_function_t _fself, kk_box_t _b_x153, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10069_fun438(kk_std_os_path__path to_0, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10069_fun438__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10069_fun438__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10069_fun438, kk_context());
  _self->to_0 = to_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10069_fun440__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun440(kk_function_t _fself, kk_box_t _b_x142, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10069_fun440(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10069_fun440, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun440(kk_function_t _fself, kk_box_t _b_x142, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _b_x137_138;
  kk_std_core_types__list _x_x441;
  kk_std_os_path__path _match_x297;
  kk_box_t _x_x442 = kk_box_dup(_b_x142, _ctx); /*9585*/
  _match_x297 = kk_std_os_path__path_unbox(_x_x442, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1 = _match_x297.parts;
    kk_std_core_types__list_dup(_x_1, _ctx);
    kk_std_os_path__path_drop(_match_x297, _ctx);
    _x_x441 = _x_1; /*list<string>*/
  }
  _b_x137_138 = kk_std_core_list_take(_x_x441, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x443;
  kk_string_t _x_x444 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x446;
  kk_std_core_types__optional _match_x295 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x137_138, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x295, _ctx)) {
    kk_box_t _box_x139 = _match_x295._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_133 = kk_std_core_types__list_unbox(_box_x139, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_133, _ctx);
    kk_std_core_types__optional_drop(_match_x295, _ctx);
    kk_box_drop(_b_x142, _ctx);
    _x_x446 = _uniq_parts_133; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x295, _ctx);
    kk_std_os_path__path _match_x296 = kk_std_os_path__path_unbox(_b_x142, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0 = _match_x296.parts;
      kk_std_core_types__list_dup(_x_0, _ctx);
      kk_std_os_path__path_drop(_match_x296, _ctx);
      _x_x446 = _x_0; /*list<string>*/
    }
  }
  _x_x443 = kk_std_os_path__new_Path(_x_x444, _x_x446, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x443, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10069_fun451__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun451(kk_function_t _fself, kk_box_t _b_x149, kk_box_t _b_x150, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10069_fun451(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10069_fun451, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun451(kk_function_t _fself, kk_box_t _b_x149, kk_box_t _b_x150, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_os_path__path _x_x452;
  kk_std_os_path__path _x_x453 = kk_std_os_path__path_unbox(_b_x149, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x454 = kk_std_os_path__path_unbox(_b_x150, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x452 = kk_std_os_path__lp__fs__rp_(_x_x453, _x_x454, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x452, _ctx);
}
static kk_unit_t kk_std_os_dir__mlift_copy_directory_10069_fun438(kk_function_t _fself, kk_box_t _b_x153, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10069_fun438__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10069_fun438__t*, _fself, _ctx);
  kk_std_os_path__path to_0 = _self->to_0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_0, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x_x2_10060;
  kk_box_t _x_x439;
  kk_box_t _x_x447 = kk_box_dup(_b_x153, _ctx); /*2872*/
  _x_x439 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10069_fun440(_ctx), _x_x447, _ctx); /*9586*/
  _x_x2_10060 = kk_std_os_path__path_unbox(_x_x439, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x448 = kk_std_os_path__path_unbox(_b_x153, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x449;
  kk_box_t _x_x450 = kk_std_core_hnd__open_none2(kk_std_os_dir__new_mlift_copy_directory_10069_fun451(_ctx), kk_std_os_path__path_box(to_0, _ctx), kk_std_os_path__path_box(_x_x2_10060, _ctx), _ctx); /*9663*/
  _x_x449 = kk_std_os_path__path_unbox(_x_x450, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(_x_x448, _x_x449, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10069_fun456__t {
  struct kk_function_s _base;
  kk_std_core_types__list dirs_0;
  kk_std_os_path__path to_0;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun456(kk_function_t _fself, kk_box_t _b_x161, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10069_fun456(kk_std_core_types__list dirs_0, kk_std_os_path__path to_0, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10069_fun456__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10069_fun456__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10069_fun456, kk_context());
  _self->dirs_0 = dirs_0;
  _self->to_0 = to_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun456(kk_function_t _fself, kk_box_t _b_x161, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10069_fun456__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10069_fun456__t*, _fself, _ctx);
  kk_std_core_types__list dirs_0 = _self->dirs_0; /* list<std/os/path/path> */
  kk_std_os_path__path to_0 = _self->to_0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core_types__list_dup(dirs_0, _ctx);kk_std_os_path__path_dup(to_0, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_0_163 = kk_Unit;
  kk_unit_unbox(_b_x161);
  kk_unit_t _x_x457 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10068(dirs_0, to_0, wild___0_0_163, _ctx);
  return kk_unit_box(_x_x457);
}

kk_unit_t kk_std_os_dir__mlift_copy_directory_10069(kk_std_os_path__path to_0, kk_std_core_types__tuple2 _y_x10018, kk_context_t* _ctx) { /* (to : std/os/path/path, (list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */ 
  {
    kk_box_t _box_x135 = _y_x10018.fst;
    kk_box_t _box_x136 = _y_x10018.snd;
    kk_std_core_types__list dirs_0 = kk_std_core_types__list_unbox(_box_x135, KK_BORROWED, _ctx);
    kk_std_core_types__list files = kk_std_core_types__list_unbox(_box_x136, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(dirs_0, _ctx);
    kk_std_core_types__list_dup(files, _ctx);
    kk_std_core_types__tuple2_drop(_y_x10018, _ctx);
    kk_unit_t x_10077 = kk_Unit;
    kk_function_t _x_x437;
    kk_std_os_path__path_dup(to_0, _ctx);
    _x_x437 = kk_std_os_dir__new_mlift_copy_directory_10069_fun438(to_0, _ctx); /*(2872) -> 2873 ()*/
    kk_std_core_list_foreach(files, _x_x437, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x455 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift_copy_directory_10069_fun456(dirs_0, to_0, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x455); return kk_Unit;
    }
    {
      kk_std_os_dir__mlift_copy_directory_10068(dirs_0, to_0, x_10077, _ctx); return kk_Unit;
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10070_fun459__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun459(kk_function_t _fself, kk_box_t _b_x166, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10070_fun459(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10070_fun459, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun459(kk_function_t _fself, kk_box_t _b_x166, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _x_x460;
  kk_std_os_path__path _x_x461 = kk_std_os_path__path_unbox(_b_x166, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x460 = kk_std_os_dir_list_directory(_x_x461, _ctx); /*list<std/os/path/path>*/
  return kk_std_core_types__list_box(_x_x460, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10070_fun462__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__mlift_copy_directory_10070_fun462(kk_function_t _fself, kk_box_t _b_x174, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10070_fun462(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10070_fun462, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10070_fun464__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun464(kk_function_t _fself, kk_box_t _b_x171, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10070_fun464(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10070_fun464, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun464(kk_function_t _fself, kk_box_t _b_x171, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  bool _x_x465;
  kk_std_os_path__path _x_x466 = kk_std_os_path__path_unbox(_b_x171, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x465 = kk_std_os_dir_is_directory(_x_x466, _ctx); /*bool*/
  return kk_bool_box(_x_x465);
}
static bool kk_std_os_dir__mlift_copy_directory_10070_fun462(kk_function_t _fself, kk_box_t _b_x174, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_box_t _x_x463 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10070_fun464(_ctx), _b_x174, _ctx); /*9586*/
  return kk_bool_unbox(_x_x463);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10070_fun468__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_1;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun468(kk_function_t _fself, kk_box_t _b_x181, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10070_fun468(kk_std_os_path__path to_1, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10070_fun468__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10070_fun468__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10070_fun468, kk_context());
  _self->to_1 = to_1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun468(kk_function_t _fself, kk_box_t _b_x181, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10070_fun468__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10070_fun468__t*, _fself, _ctx);
  kk_std_os_path__path to_1 = _self->to_1; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_1, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2 _y_x10018_0_183 = kk_std_core_types__tuple2_unbox(_b_x181, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x_x469 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10069(to_1, _y_x10018_0_183, _ctx);
  return kk_unit_box(_x_x469);
}

kk_unit_t kk_std_os_dir__mlift_copy_directory_10070(kk_std_os_path__path dir, kk_std_os_path__path to_1, kk_unit_t wild__, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path, wild_ : ()) -> <exn,fsys> () */ 
  kk_std_core_types__list all;
  kk_box_t _x_x458 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10070_fun459(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*9586*/
  all = kk_std_core_types__list_unbox(_x_x458, KK_OWNED, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2 x_0_10079;
  kk_function_t _brw_x292 = kk_std_os_dir__new_mlift_copy_directory_10070_fun462(_ctx); /*(2610) -> 2611 bool*/;
  kk_std_core_types__tuple2 _brw_x293 = kk_std_core_list_partition(all, _brw_x292, _ctx); /*(list<2610>, list<2610>)*/;
  kk_function_drop(_brw_x292, _ctx);
  x_0_10079 = _brw_x293; /*(list<std/os/path/path>, list<std/os/path/path>)*/
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2_drop(x_0_10079, _ctx);
    kk_box_t _x_x467 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift_copy_directory_10070_fun468(to_1, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x467); return kk_Unit;
  }
  {
    kk_std_os_dir__mlift_copy_directory_10069(to_1, x_0_10079, _ctx); return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun472__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir_0;
  kk_std_os_path__path to_2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun472(kk_function_t _fself, kk_box_t _b_x185, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun472(kk_std_os_path__path dir_0, kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun472__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun472__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun472, kk_context());
  _self->dir_0 = dir_0;
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun472(kk_function_t _fself, kk_box_t _b_x185, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun472__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun472__t*, _fself, _ctx);
  kk_std_os_path__path dir_0 = _self->dir_0; /* std/os/path/path */
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir_0, _ctx);kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_unit_t wild___1_256 = kk_Unit;
  kk_unit_unbox(_b_x185);
  kk_unit_t _x_x473 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10070(dir_0, to_2, wild___1_256, _ctx);
  return kk_unit_box(_x_x473);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun475__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun475(kk_function_t _fself, kk_box_t _b_x188, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun475(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun475, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun475(kk_function_t _fself, kk_box_t _b_x188, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _x_x476;
  kk_std_os_path__path _x_x477 = kk_std_os_path__path_unbox(_b_x188, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x476 = kk_std_os_dir_list_directory(_x_x477, _ctx); /*list<std/os/path/path>*/
  return kk_std_core_types__list_box(_x_x476, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun478__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_copy_directory_fun478(kk_function_t _fself, kk_box_t _b_x196, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun478(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun478, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun480__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun480(kk_function_t _fself, kk_box_t _b_x193, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun480(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun480, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun480(kk_function_t _fself, kk_box_t _b_x193, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  bool _x_x481;
  kk_std_os_path__path _x_x482 = kk_std_os_path__path_unbox(_b_x193, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x481 = kk_std_os_dir_is_directory(_x_x482, _ctx); /*bool*/
  return kk_bool_box(_x_x481);
}
static bool kk_std_os_dir_copy_directory_fun478(kk_function_t _fself, kk_box_t _b_x196, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_box_t _x_x479 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun480(_ctx), _b_x196, _ctx); /*9586*/
  return kk_bool_unbox(_x_x479);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun484__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun484(kk_function_t _fself, kk_box_t _b_x203, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun484(kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun484__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun484__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun484, kk_context());
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun484(kk_function_t _fself, kk_box_t _b_x203, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun484__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun484__t*, _fself, _ctx);
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2 _y_x10018_1_257 = kk_std_core_types__tuple2_unbox(_b_x203, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x_x485 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10069(to_2, _y_x10018_1_257, _ctx);
  return kk_unit_box(_x_x485);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun487__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun487(kk_function_t _fself, kk_box_t _b_x222, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun487(kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun487__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun487__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun487, kk_context());
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun489__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun489(kk_function_t _fself, kk_box_t _b_x211, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun489(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun489, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun489(kk_function_t _fself, kk_box_t _b_x211, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _b_x206_207;
  kk_std_core_types__list _x_x490;
  kk_std_os_path__path _match_x288;
  kk_box_t _x_x491 = kk_box_dup(_b_x211, _ctx); /*9585*/
  _match_x288 = kk_std_os_path__path_unbox(_x_x491, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1_1 = _match_x288.parts;
    kk_std_core_types__list_dup(_x_1_1, _ctx);
    kk_std_os_path__path_drop(_match_x288, _ctx);
    _x_x490 = _x_1_1; /*list<string>*/
  }
  _b_x206_207 = kk_std_core_list_take(_x_x490, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x492;
  kk_string_t _x_x493 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x495;
  kk_std_core_types__optional _match_x286 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x206_207, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x286, _ctx)) {
    kk_box_t _box_x208 = _match_x286._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_133_1 = kk_std_core_types__list_unbox(_box_x208, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_133_1, _ctx);
    kk_std_core_types__optional_drop(_match_x286, _ctx);
    kk_box_drop(_b_x211, _ctx);
    _x_x495 = _uniq_parts_133_1; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x286, _ctx);
    kk_std_os_path__path _match_x287 = kk_std_os_path__path_unbox(_b_x211, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0_1 = _match_x287.parts;
      kk_std_core_types__list_dup(_x_0_1, _ctx);
      kk_std_os_path__path_drop(_match_x287, _ctx);
      _x_x495 = _x_0_1; /*list<string>*/
    }
  }
  _x_x492 = kk_std_os_path__new_Path(_x_x493, _x_x495, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x492, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun500__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun500(kk_function_t _fself, kk_box_t _b_x218, kk_box_t _b_x219, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun500(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun500, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun500(kk_function_t _fself, kk_box_t _b_x218, kk_box_t _b_x219, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_os_path__path _x_x501;
  kk_std_os_path__path _x_x502 = kk_std_os_path__path_unbox(_b_x218, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x503 = kk_std_os_path__path_unbox(_b_x219, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x501 = kk_std_os_path__lp__fs__rp_(_x_x502, _x_x503, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x501, _ctx);
}
static kk_unit_t kk_std_os_dir_copy_directory_fun487(kk_function_t _fself, kk_box_t _b_x222, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun487__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun487__t*, _fself, _ctx);
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x_x2_10060_0;
  kk_box_t _x_x488;
  kk_box_t _x_x496 = kk_box_dup(_b_x222, _ctx); /*2872*/
  _x_x488 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun489(_ctx), _x_x496, _ctx); /*9586*/
  _x_x2_10060_0 = kk_std_os_path__path_unbox(_x_x488, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x497 = kk_std_os_path__path_unbox(_b_x222, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x498;
  kk_box_t _x_x499 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_directory_fun500(_ctx), kk_std_os_path__path_box(to_2, _ctx), kk_std_os_path__path_box(_x_x2_10060_0, _ctx), _ctx); /*9663*/
  _x_x498 = kk_std_os_path__path_unbox(_x_x499, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(_x_x497, _x_x498, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun505__t {
  struct kk_function_s _base;
  kk_std_core_types__list dirs_1;
  kk_std_os_path__path to_2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun505(kk_function_t _fself, kk_box_t _b_x230, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun505(kk_std_core_types__list dirs_1, kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun505__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun505__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun505, kk_context());
  _self->dirs_1 = dirs_1;
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun505(kk_function_t _fself, kk_box_t _b_x230, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun505__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun505__t*, _fself, _ctx);
  kk_std_core_types__list dirs_1 = _self->dirs_1; /* list<std/os/path/path> */
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core_types__list_dup(dirs_1, _ctx);kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_1_258 = kk_Unit;
  kk_unit_unbox(_b_x230);
  kk_unit_t _x_x506 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10068(dirs_1, to_2, wild___0_1_258, _ctx);
  return kk_unit_box(_x_x506);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun507__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun507(kk_function_t _fself, kk_box_t _b_x247, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun507(kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun507__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun507__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun507, kk_context());
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun509__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun509(kk_function_t _fself, kk_box_t _b_x236, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun509(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun509, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun509(kk_function_t _fself, kk_box_t _b_x236, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _b_x231_232;
  kk_std_core_types__list _x_x510;
  kk_std_os_path__path _match_x285;
  kk_box_t _x_x511 = kk_box_dup(_b_x236, _ctx); /*9585*/
  _match_x285 = kk_std_os_path__path_unbox(_x_x511, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1_0_0 = _match_x285.parts;
    kk_std_core_types__list_dup(_x_1_0_0, _ctx);
    kk_std_os_path__path_drop(_match_x285, _ctx);
    _x_x510 = _x_1_0_0; /*list<string>*/
  }
  _b_x231_232 = kk_std_core_list_take(_x_x510, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x512;
  kk_string_t _x_x513 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x515;
  kk_std_core_types__optional _match_x283 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x231_232, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x283, _ctx)) {
    kk_box_t _box_x233 = _match_x283._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_133_0_0 = kk_std_core_types__list_unbox(_box_x233, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_133_0_0, _ctx);
    kk_std_core_types__optional_drop(_match_x283, _ctx);
    kk_box_drop(_b_x236, _ctx);
    _x_x515 = _uniq_parts_133_0_0; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x283, _ctx);
    kk_std_os_path__path _match_x284 = kk_std_os_path__path_unbox(_b_x236, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0_0_0 = _match_x284.parts;
      kk_std_core_types__list_dup(_x_0_0_0, _ctx);
      kk_std_os_path__path_drop(_match_x284, _ctx);
      _x_x515 = _x_0_0_0; /*list<string>*/
    }
  }
  _x_x512 = kk_std_os_path__new_Path(_x_x513, _x_x515, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x512, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun520__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun520(kk_function_t _fself, kk_box_t _b_x243, kk_box_t _b_x244, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun520(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun520, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun520(kk_function_t _fself, kk_box_t _b_x243, kk_box_t _b_x244, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_os_path__path _x_x521;
  kk_std_os_path__path _x_x522 = kk_std_os_path__path_unbox(_b_x243, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x523 = kk_std_os_path__path_unbox(_b_x244, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x521 = kk_std_os_path__lp__fs__rp_(_x_x522, _x_x523, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x521, _ctx);
}
static kk_unit_t kk_std_os_dir_copy_directory_fun507(kk_function_t _fself, kk_box_t _b_x247, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun507__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun507__t*, _fself, _ctx);
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x_x2_0_10063_0;
  kk_box_t _x_x508;
  kk_box_t _x_x516 = kk_box_dup(_b_x247, _ctx); /*2872*/
  _x_x508 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun509(_ctx), _x_x516, _ctx); /*9586*/
  _x_x2_0_10063_0 = kk_std_os_path__path_unbox(_x_x508, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x517 = kk_std_os_path__path_unbox(_b_x247, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x518;
  kk_box_t _x_x519 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_directory_fun520(_ctx), kk_std_os_path__path_box(to_2, _ctx), kk_std_os_path__path_box(_x_x2_0_10063_0, _ctx), _ctx); /*9663*/
  _x_x518 = kk_std_os_path__path_unbox(_x_x519, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_directory(_x_x517, _x_x518, _ctx); return kk_Unit;
}

kk_unit_t kk_std_os_dir_copy_directory(kk_std_os_path__path dir_0, kk_std_os_path__path to_2, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path) -> <pure,fsys> () */ 
  kk_unit_t x_1_10081 = kk_Unit;
  kk_std_os_path__path _x_x470 = kk_std_os_path__path_dup(to_2, _ctx); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x_x470, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x471 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun472(dir_0, to_2, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x471); return kk_Unit;
  }
  {
    kk_std_core_types__list all_0;
    kk_box_t _x_x474 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun475(_ctx), kk_std_os_path__path_box(dir_0, _ctx), _ctx); /*9586*/
    all_0 = kk_std_core_types__list_unbox(_x_x474, KK_OWNED, _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__tuple2 x_2_10084;
    kk_function_t _brw_x289 = kk_std_os_dir_new_copy_directory_fun478(_ctx); /*(2610) -> 2611 bool*/;
    kk_std_core_types__tuple2 _brw_x290 = kk_std_core_list_partition(all_0, _brw_x289, _ctx); /*(list<2610>, list<2610>)*/;
    kk_function_drop(_brw_x289, _ctx);
    x_2_10084 = _brw_x290; /*(list<std/os/path/path>, list<std/os/path/path>)*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__tuple2_drop(x_2_10084, _ctx);
      kk_box_t _x_x483 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun484(to_2, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x483); return kk_Unit;
    }
    {
      kk_box_t _box_x204 = x_2_10084.fst;
      kk_box_t _box_x205 = x_2_10084.snd;
      kk_std_core_types__list dirs_1 = kk_std_core_types__list_unbox(_box_x204, KK_BORROWED, _ctx);
      kk_std_core_types__list files_0 = kk_std_core_types__list_unbox(_box_x205, KK_BORROWED, _ctx);
      kk_std_core_types__list_dup(dirs_1, _ctx);
      kk_std_core_types__list_dup(files_0, _ctx);
      kk_std_core_types__tuple2_drop(x_2_10084, _ctx);
      kk_unit_t x_3_10087 = kk_Unit;
      kk_function_t _x_x486;
      kk_std_os_path__path_dup(to_2, _ctx);
      _x_x486 = kk_std_os_dir_new_copy_directory_fun487(to_2, _ctx); /*(2872) -> 2873 ()*/
      kk_std_core_list_foreach(files_0, _x_x486, _ctx);
      if (kk_yielding(kk_context())) {
        kk_box_t _x_x504 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun505(dirs_1, to_2, _ctx), _ctx); /*2401*/
        kk_unit_unbox(_x_x504); return kk_Unit;
      }
      {
        kk_std_core_list_foreach(dirs_1, kk_std_os_dir_new_copy_directory_fun507(to_2, _ctx), _ctx); return kk_Unit;
      }
    }
  }
}
 
// Copy a file to a directory


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun525__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_to_dir_fun525(kk_function_t _fself, kk_box_t _b_x265, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun525(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_to_dir_fun525, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_to_dir_fun525(kk_function_t _fself, kk_box_t _b_x265, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _b_x260_261;
  kk_std_core_types__list _x_x526;
  kk_std_os_path__path _match_x279;
  kk_box_t _x_x527 = kk_box_dup(_b_x265, _ctx); /*9585*/
  _match_x279 = kk_std_os_path__path_unbox(_x_x527, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1 = _match_x279.parts;
    kk_std_core_types__list_dup(_x_1, _ctx);
    kk_std_os_path__path_drop(_match_x279, _ctx);
    _x_x526 = _x_1; /*list<string>*/
  }
  _b_x260_261 = kk_std_core_list_take(_x_x526, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x528;
  kk_string_t _x_x529 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x531;
  kk_std_core_types__optional _match_x277 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x260_261, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x277, _ctx)) {
    kk_box_t _box_x262 = _match_x277._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_133 = kk_std_core_types__list_unbox(_box_x262, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_133, _ctx);
    kk_std_core_types__optional_drop(_match_x277, _ctx);
    kk_box_drop(_b_x265, _ctx);
    _x_x531 = _uniq_parts_133; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x277, _ctx);
    kk_std_os_path__path _match_x278 = kk_std_os_path__path_unbox(_b_x265, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0 = _match_x278.parts;
      kk_std_core_types__list_dup(_x_0, _ctx);
      kk_std_os_path__path_drop(_match_x278, _ctx);
      _x_x531 = _x_0; /*list<string>*/
    }
  }
  _x_x528 = kk_std_os_path__new_Path(_x_x529, _x_x531, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x528, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun536__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_to_dir_fun536(kk_function_t _fself, kk_box_t _b_x272, kk_box_t _b_x273, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun536(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_to_dir_fun536, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_to_dir_fun536(kk_function_t _fself, kk_box_t _b_x272, kk_box_t _b_x273, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_os_path__path _x_x537;
  kk_std_os_path__path _x_x538 = kk_std_os_path__path_unbox(_b_x272, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x539 = kk_std_os_path__path_unbox(_b_x273, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x537 = kk_std_os_path__lp__fs__rp_(_x_x538, _x_x539, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x537, _ctx);
}

kk_unit_t kk_std_os_dir_copy_file_to_dir(kk_std_os_path__path from, kk_std_os_path__path dir, kk_context_t* _ctx) { /* (from : std/os/path/path, dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_std_os_path__path _x_x2_10066;
  kk_box_t _x_x524;
  kk_box_t _x_x532;
  kk_std_os_path__path _x_x533 = kk_std_os_path__path_dup(from, _ctx); /*std/os/path/path*/
  _x_x532 = kk_std_os_path__path_box(_x_x533, _ctx); /*9585*/
  _x_x524 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_to_dir_fun525(_ctx), _x_x532, _ctx); /*9586*/
  _x_x2_10066 = kk_std_os_path__path_unbox(_x_x524, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x534;
  kk_box_t _x_x535 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_file_to_dir_fun536(_ctx), kk_std_os_path__path_box(dir, _ctx), kk_std_os_path__path_box(_x_x2_10066, _ctx), _ctx); /*9663*/
  _x_x534 = kk_std_os_path__path_unbox(_x_x535, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(from, _x_x534, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}

bool kk_std_os_dir_prim_is_file(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys bool */ 
  return kk_os_is_file(path,kk_context());
}

// initialization
void kk_std_os_dir__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_bool__init(_ctx);
  kk_std_core_order__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_sslice__init(_ctx);
  kk_std_core_list__init(_ctx);
  kk_std_core_maybe__init(_ctx);
  kk_std_core_maybe2__init(_ctx);
  kk_std_core_either__init(_ctx);
  kk_std_core_tuple__init(_ctx);
  kk_std_core_lazy__init(_ctx);
  kk_std_core_show__init(_ctx);
  kk_std_core_debug__init(_ctx);
  kk_std_core_delayed__init(_ctx);
  kk_std_core_console__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_dir__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_console__done(_ctx);
  kk_std_core_delayed__done(_ctx);
  kk_std_core_debug__done(_ctx);
  kk_std_core_show__done(_ctx);
  kk_std_core_lazy__done(_ctx);
  kk_std_core_tuple__done(_ctx);
  kk_std_core_either__done(_ctx);
  kk_std_core_maybe2__done(_ctx);
  kk_std_core_maybe__done(_ctx);
  kk_std_core_list__done(_ctx);
  kk_std_core_sslice__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_order__done(_ctx);
  kk_std_core_bool__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
