// Koka generated module: std/os/dir, koka version: 3.1.3, platform: 64-bit
#include "std_os_dir.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_exn__error kk_os_ensure_dir_error( kk_string_t path, kk_integer_t mode, kk_context_t* ctx ) {
  int m  = kk_integer_clamp32(mode,ctx);
  const int err = kk_os_ensure_dir(path,m,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core_exn__error kk_os_copy_file_error( kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* ctx ) {
  const int err = kk_os_copy_file(from,to,preserve_mtime,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core_exn__error kk_os_list_directory_prim( kk_string_t dir, kk_context_t* ctx ) {
  kk_vector_t contents;
  const int err = kk_os_list_directory(dir,&contents,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_vector_box(contents,ctx),ctx);
}


kk_std_core_exn__exception kk_std_os_dir_prepend(kk_std_core_exn__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x_x217;
  kk_string_t _x_x218;
  kk_string_t _x_x219;
  kk_define_string_literal(, _s_x220, 2, ": ", _ctx)
  _x_x219 = kk_string_dup(_s_x220, _ctx); /*string*/
  kk_string_t _x_x221;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x_x221 = _x; /*string*/
  }
  _x_x218 = kk_std_core_types__lp__plus__plus__rp_(_x_x219, _x_x221, _ctx); /*string*/
  _x_x217 = kk_std_core_types__lp__plus__plus__rp_(pre, _x_x218, _ctx); /*string*/
  kk_std_core_exn__exception_info _x_x222;
  {
    kk_std_core_exn__exception_info _x_0 = exn.info;
    kk_std_core_exn__exception_info_dup(_x_0, _ctx);
    kk_std_core_exn__exception_drop(exn, _ctx);
    _x_x222 = _x_0; /*exception-info*/
  }
  return kk_std_core_exn__new_Exception(_x_x217, _x_x222, _ctx);
}

kk_std_core_exn__error kk_std_os_dir_prim_copy_file(kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* _ctx) { /* (from : string, to : string, preserve-mtime : bool) -> fsys error<()> */ 
  return kk_os_copy_file_error(from,to,preserve_mtime,kk_context());
}
 
// Copy a file.


// lift anonymous function
struct kk_std_os_dir_copy_file_fun224__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun224(kk_function_t _fself, kk_box_t _b_x2, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun224(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun224, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun224(kk_function_t _fself, kk_box_t _b_x2, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x225;
  kk_std_os_path__path _x_x226 = kk_std_os_path__path_unbox(_b_x2, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x225 = kk_std_os_path_string(_x_x226, _ctx); /*string*/
  return kk_string_box(_x_x225);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun230__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun230(kk_function_t _fself, kk_box_t _b_x7, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun230(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun230, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun230(kk_function_t _fself, kk_box_t _b_x7, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x231;
  kk_std_os_path__path _x_x232 = kk_std_os_path__path_unbox(_b_x7, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x231 = kk_std_os_path_string(_x_x232, _ctx); /*string*/
  return kk_string_box(_x_x231);
}

kk_unit_t kk_std_os_dir_copy_file(kk_std_os_path__path from, kk_std_os_path__path to, kk_std_core_types__optional preserve_mtime, kk_context_t* _ctx) { /* (from : std/os/path/path, to : std/os/path/path, preserve-mtime : ? bool) -> <exn,fsys> () */ 
  kk_string_t _x_x1_10259;
  kk_box_t _x_x223;
  kk_box_t _x_x227;
  kk_std_os_path__path _x_x228 = kk_std_os_path__path_dup(from, _ctx); /*std/os/path/path*/
  _x_x227 = kk_std_os_path__path_box(_x_x228, _ctx); /*9585*/
  _x_x223 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun224(_ctx), _x_x227, _ctx); /*9586*/
  _x_x1_10259 = kk_string_unbox(_x_x223); /*string*/
  kk_string_t _x_x2_10260;
  kk_box_t _x_x229;
  kk_box_t _x_x233;
  kk_std_os_path__path _x_x234 = kk_std_os_path__path_dup(to, _ctx); /*std/os/path/path*/
  _x_x233 = kk_std_os_path__path_box(_x_x234, _ctx); /*9585*/
  _x_x229 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun230(_ctx), _x_x233, _ctx); /*9586*/
  _x_x2_10260 = kk_string_unbox(_x_x229); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<fsys,exn>>*/;
  kk_std_core_exn__error x;
  bool _x_x235;
  if (kk_std_core_types__is_Optional(preserve_mtime, _ctx)) {
    kk_box_t _box_x10 = preserve_mtime._cons._Optional.value;
    bool _uniq_preserve_mtime_93 = kk_bool_unbox(_box_x10);
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x_x235 = _uniq_preserve_mtime_93; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x_x235 = true; /*bool*/
  }
  x = kk_std_os_dir_prim_copy_file(_x_x1_10259, _x_x2_10260, _x_x235, _ctx); /*error<()>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_std_core_exn__is_Error(x, _ctx)) {
    kk_std_core_exn__exception exn = x._cons.Error.exception;
    kk_std_core_exn__exception_dup(exn, _ctx);
    kk_std_core_exn__error_drop(x, _ctx);
    kk_evv_t w_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_string_t x_0;
    kk_string_t _x_x236 = kk_std_os_path_string(from, _ctx); /*string*/
    x_0 = kk_std_core_show_string_fs_show(_x_x236, _ctx); /*string*/
    kk_unit_t keep_0 = kk_Unit;
    kk_evv_set(w_0,kk_context());
    kk_evv_t w_1 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_string_t x_1;
    kk_string_t _x_x237 = kk_std_os_path_string(to, _ctx); /*string*/
    x_1 = kk_std_core_show_string_fs_show(_x_x237, _ctx); /*string*/
    kk_unit_t keep_1 = kk_Unit;
    kk_evv_set(w_1,kk_context());
    kk_string_t _x_x2_0_10265;
    kk_string_t _x_x238;
    kk_define_string_literal(, _s_x239, 15, "unable to copy ", _ctx)
    _x_x238 = kk_string_dup(_s_x239, _ctx); /*string*/
    kk_string_t _x_x240;
    kk_string_t _x_x241;
    kk_string_t _x_x242;
    kk_define_string_literal(, _s_x243, 4, " to ", _ctx)
    _x_x242 = kk_string_dup(_s_x243, _ctx); /*string*/
    _x_x241 = kk_std_core_types__lp__plus__plus__rp_(_x_x242, x_1, _ctx); /*string*/
    _x_x240 = kk_std_core_types__lp__plus__plus__rp_(x_0, _x_x241, _ctx); /*string*/
    _x_x2_0_10265 = kk_std_core_types__lp__plus__plus__rp_(_x_x238, _x_x240, _ctx); /*string*/
    kk_evv_t w_1_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_std_core_exn__exception x_1_0;
    kk_string_t _x_x244;
    kk_string_t _x_x245;
    kk_string_t _x_x246;
    kk_define_string_literal(, _s_x247, 2, ": ", _ctx)
    _x_x246 = kk_string_dup(_s_x247, _ctx); /*string*/
    kk_string_t _x_x248;
    {
      kk_string_t _x = exn.message;
      kk_string_dup(_x, _ctx);
      _x_x248 = _x; /*string*/
    }
    _x_x245 = kk_std_core_types__lp__plus__plus__rp_(_x_x246, _x_x248, _ctx); /*string*/
    _x_x244 = kk_std_core_types__lp__plus__plus__rp_(_x_x2_0_10265, _x_x245, _ctx); /*string*/
    kk_std_core_exn__exception_info _x_x249;
    {
      kk_std_core_exn__exception_info _x_0 = exn.info;
      kk_std_core_exn__exception_info_dup(_x_0, _ctx);
      kk_std_core_exn__exception_drop(exn, _ctx);
      _x_x249 = _x_0; /*exception-info*/
    }
    x_1_0 = kk_std_core_exn__new_Exception(_x_x244, _x_x249, _ctx); /*exception*/
    kk_unit_t keep_1_0 = kk_Unit;
    kk_evv_set(w_1_0,kk_context());
    kk_std_core_hnd__ev ev_10298 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t _x_x250;
    {
      struct kk_std_core_hnd_Ev* _con_x251 = kk_std_core_hnd__as_Ev(ev_10298, _ctx);
      kk_box_t _box_x11 = _con_x251->hnd;
      int32_t m = _con_x251->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x11, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x207;
      kk_std_core_hnd__clause1 _brw_x208 = kk_std_core_exn_throw_exn_fs__select(h, _ctx); /*hnd/clause1<exception,274,exn,275,276>*/;
      kk_datatype_ptr_dropn(h, (KK_I32(2)), _ctx);
      _match_x207 = _brw_x208; /*hnd/clause1<exception,274,exn,275,276>*/
      {
        kk_function_t _fun_unbox_x15 = _match_x207.clause;
        _x_x250 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x15, (_fun_unbox_x15, m, ev_10298, kk_std_core_exn__exception_box(x_1_0, _ctx), _ctx), _ctx); /*46*/
      }
    }
    kk_unit_unbox(_x_x250); return kk_Unit;
  }
  {
    kk_std_core_exn__error_drop(x, _ctx);
    kk_std_os_path__path_drop(to, _ctx);
    kk_std_os_path__path_drop(from, _ctx);
    kk_Unit; return kk_Unit;
  }
}

kk_std_core_exn__error kk_std_os_dir_ensure_dir_err(kk_string_t path, kk_integer_t mode, kk_context_t* _ctx) { /* (path : string, mode : int) -> fsys error<()> */ 
  return kk_os_ensure_dir_error(path,mode,kk_context());
}
 
// Ensure a directory path exists


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun253__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun253(kk_function_t _fself, kk_box_t _b_x21, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun253(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun253, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun253(kk_function_t _fself, kk_box_t _b_x21, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x254;
  kk_std_os_path__path _x_x255 = kk_std_os_path__path_unbox(_b_x21, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x254 = kk_std_os_path_string(_x_x255, _ctx); /*string*/
  return kk_string_box(_x_x254);
}

kk_unit_t kk_std_os_dir_ensure_dir(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_string_t _x_x1_10268;
  kk_box_t _x_x252;
  kk_box_t _x_x256;
  kk_std_os_path__path _x_x257 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x_x256 = kk_std_os_path__path_box(_x_x257, _ctx); /*9585*/
  _x_x252 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun253(_ctx), _x_x256, _ctx); /*9586*/
  _x_x1_10268 = kk_string_unbox(_x_x252); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<fsys,exn>>*/;
  kk_std_core_exn__error x = kk_std_os_dir_ensure_dir_err(_x_x1_10268, kk_integer_from_small(-1), _ctx); /*error<()>*/;
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_std_core_exn__is_Error(x, _ctx)) {
    kk_std_core_exn__exception exn = x._cons.Error.exception;
    kk_std_core_exn__exception_dup(exn, _ctx);
    kk_std_core_exn__error_drop(x, _ctx);
    kk_evv_t w_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_string_t x_0;
    kk_string_t _x_x258 = kk_std_os_path_string(dir, _ctx); /*string*/
    x_0 = kk_std_core_show_string_fs_show(_x_x258, _ctx); /*string*/
    kk_unit_t keep_0 = kk_Unit;
    kk_evv_set(w_0,kk_context());
    kk_string_t _x_x2_0_10272;
    kk_string_t _x_x259;
    kk_define_string_literal(, _s_x260, 27, "unable to create directory ", _ctx)
    _x_x259 = kk_string_dup(_s_x260, _ctx); /*string*/
    _x_x2_0_10272 = kk_std_core_types__lp__plus__plus__rp_(_x_x259, x_0, _ctx); /*string*/
    kk_evv_t w_1 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_std_core_exn__exception x_1;
    kk_string_t _x_x261;
    kk_string_t _x_x262;
    kk_string_t _x_x263;
    kk_define_string_literal(, _s_x264, 2, ": ", _ctx)
    _x_x263 = kk_string_dup(_s_x264, _ctx); /*string*/
    kk_string_t _x_x265;
    {
      kk_string_t _x = exn.message;
      kk_string_dup(_x, _ctx);
      _x_x265 = _x; /*string*/
    }
    _x_x262 = kk_std_core_types__lp__plus__plus__rp_(_x_x263, _x_x265, _ctx); /*string*/
    _x_x261 = kk_std_core_types__lp__plus__plus__rp_(_x_x2_0_10272, _x_x262, _ctx); /*string*/
    kk_std_core_exn__exception_info _x_x266;
    {
      kk_std_core_exn__exception_info _x_0 = exn.info;
      kk_std_core_exn__exception_info_dup(_x_0, _ctx);
      kk_std_core_exn__exception_drop(exn, _ctx);
      _x_x266 = _x_0; /*exception-info*/
    }
    x_1 = kk_std_core_exn__new_Exception(_x_x261, _x_x266, _ctx); /*exception*/
    kk_unit_t keep_1 = kk_Unit;
    kk_evv_set(w_1,kk_context());
    kk_std_core_hnd__ev ev_10309 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t _x_x267;
    {
      struct kk_std_core_hnd_Ev* _con_x268 = kk_std_core_hnd__as_Ev(ev_10309, _ctx);
      kk_box_t _box_x24 = _con_x268->hnd;
      int32_t m = _con_x268->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x24, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x205;
      kk_std_core_hnd__clause1 _brw_x206 = kk_std_core_exn_throw_exn_fs__select(h, _ctx); /*hnd/clause1<exception,274,exn,275,276>*/;
      kk_datatype_ptr_dropn(h, (KK_I32(2)), _ctx);
      _match_x205 = _brw_x206; /*hnd/clause1<exception,274,exn,275,276>*/
      {
        kk_function_t _fun_unbox_x28 = _match_x205.clause;
        _x_x267 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x28, (_fun_unbox_x28, m, ev_10309, kk_std_core_exn__exception_box(x_1, _ctx), _ctx), _ctx); /*46*/
      }
    }
    kk_unit_unbox(_x_x267); return kk_Unit;
  }
  {
    kk_box_t _box_x32 = x._cons.Ok.result;
    kk_unit_t _pat_3_0 = kk_unit_unbox(_box_x32);
    kk_std_core_exn__error_drop(x, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    kk_Unit; return kk_Unit;
  }
}

bool kk_std_os_dir_prim_is_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys bool */ 
  return kk_os_is_directory(dir,kk_context());
}

kk_std_core_exn__error kk_std_os_dir_prim_list_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys error<vector<string>> */ 
  return kk_os_list_directory_prim(dir,kk_context());
}
 
// lifted local: @lift-list-directory@10194, list-directory, @spec-x10126
// specialized: std/core/list/@unroll-map@10010, on parameters @uniq-f@10121, using:
// @uniq-f@10121 = fn<(fsys :: X)>(name: string){
//   val p2@10010 : std/os/path/path;
//   val parts@0@10093 : (list :: V -> V)<string>;
//   val parts@10091 : ? ((list :: V -> V)<string>);
//   std/os/path/Path((match (dir) {
//       ((@skip std/os/path/Path((@x: string) : string, (@pat@0@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@0: std/os/path/path)
//          -> @x;
//     }), (match (parts@10091) {
//       ((std/core/types/@Optional((@uniq-parts@95: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@0: ? ((list :: V -> V)<string>))
//          -> @uniq-parts@95;
//       ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@0: ? ((list :: V -> V)<string>))
//          -> std/core/types/Nil<string>;
//     }));
// }

kk_std_core_types__list kk_std_os_dir__trmc_lift_list_directory_10195(kk_std_os_path__path dir, kk_std_core_types__list _uniq_xs_10120, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (dir : std/os/path/path, list<string>, ctx<list<std/os/path/path>>) -> fsys list<std/os/path/path> */ 
  if (kk_std_core_types__is_Cons(_uniq_xs_10120, _ctx)) {
    struct kk_std_core_types_Cons* _con_x270 = kk_std_core_types__as_Cons(_uniq_xs_10120, _ctx);
    kk_box_t _box_x33 = _con_x270->head;
    kk_std_core_types__list _uniq_xx_10124 = _con_x270->tail;
    kk_string_t _uniq_x_10123 = kk_string_unbox(_box_x33);
    kk_reuse_t _ru_x211 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10120, _ctx)) {
      _ru_x211 = (kk_datatype_ptr_reuse(_uniq_xs_10120, _ctx));
    }
    else {
      kk_string_dup(_uniq_x_10123, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10124, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10120, _ctx);
    }
    kk_std_os_path__path p2_10010 = kk_std_os_path_path(_uniq_x_10123, _ctx); /*std/os/path/path*/;
    kk_std_core_types__list parts_0_10093;
    {
      kk_std_core_types__list _x_0 = p2_10010.parts;
      kk_std_core_types__list_dup(_x_0, _ctx);
      if (kk_std_core_types__is_Nil(_x_0, _ctx)) {
        kk_std_os_path__path_drop(p2_10010, _ctx);
        parts_0_10093 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
      }
      else {
        kk_std_core_types__list_drop(_x_0, _ctx);
        kk_std_core_types__list _x_x271;
        {
          kk_std_core_types__list _x_0_0 = p2_10010.parts;
          kk_std_core_types__list_dup(_x_0_0, _ctx);
          kk_std_os_path__path_drop(p2_10010, _ctx);
          _x_x271 = _x_0_0; /*list<string>*/
        }
        parts_0_10093 = kk_std_core_list__unroll_reverse_acc_10003(kk_std_core_types__new_Nil(_ctx), _x_x271, _ctx); /*list<string>*/
      }
    }
    kk_std_core_types__list _b_x34_35;
    if (kk_std_core_types__is_Nil(parts_0_10093, _ctx)) {
      kk_std_core_types__list _x_1 = dir.parts;
      kk_std_core_types__list_dup(_x_1, _ctx);
      _b_x34_35 = _x_1; /*list<string>*/
    }
    else {
      kk_std_core_types__list _x_x272;
      {
        kk_std_core_types__list _x_1_0 = dir.parts;
        kk_std_core_types__list_dup(_x_1_0, _ctx);
        _x_x272 = _x_1_0; /*list<string>*/
      }
      _b_x34_35 = kk_std_os_path__unroll_push_parts_10000(parts_0_10093, _x_x272, _ctx); /*list<string>*/
    }
    kk_std_core_types__list _trmc_x10215 = kk_datatype_null(); /*list<std/os/path/path>*/;
    kk_std_core_types__list _trmc_x10216;
    kk_box_t _x_x273;
    kk_std_os_path__path _x_x274;
    kk_string_t _x_x275;
    {
      kk_string_t _x = dir.root;
      kk_string_dup(_x, _ctx);
      _x_x275 = _x; /*string*/
    }
    kk_std_core_types__list _x_x276;
    kk_std_core_types__optional _match_x204 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x34_35, _ctx), _ctx); /*? 7*/;
    if (kk_std_core_types__is_Optional(_match_x204, _ctx)) {
      kk_box_t _box_x36 = _match_x204._cons._Optional.value;
      kk_std_core_types__list _uniq_parts_95 = kk_std_core_types__list_unbox(_box_x36, KK_BORROWED, _ctx);
      kk_std_core_types__list_dup(_uniq_parts_95, _ctx);
      kk_std_core_types__optional_drop(_match_x204, _ctx);
      _x_x276 = _uniq_parts_95; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x204, _ctx);
      _x_x276 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
    }
    _x_x274 = kk_std_os_path__new_Path(_x_x275, _x_x276, _ctx); /*std/os/path/path*/
    _x_x273 = kk_std_os_path__path_box(_x_x274, _ctx); /*82*/
    _trmc_x10216 = kk_std_core_types__new_Cons(_ru_x211, 0, _x_x273, _trmc_x10215, _ctx); /*list<std/os/path/path>*/
    kk_field_addr_t _b_x46_51 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10216, _ctx)->tail, _ctx); /*@field-addr<list<std/os/path/path>>*/;
    kk_std_core_types__cctx _brw_x202;
    kk_std_core_types__cctx _x_x277 = kk_std_core_types__cctx_dup(_acc, _ctx); /*ctx<list<std/os/path/path>>*/
    _brw_x202 = kk_cctx_extend_linear(_x_x277,(kk_std_core_types__list_box(_trmc_x10216, _ctx)),_b_x46_51,kk_context()); /*ctx<0>*/
    kk_std_core_types__list _brw_x203 = kk_std_os_dir__trmc_lift_list_directory_10195(dir, _uniq_xx_10124, _brw_x202, _ctx); /*list<std/os/path/path>*/;
    kk_std_core_types__cctx_drop(_brw_x202, _ctx);
    return _brw_x203;
  }
  {
    kk_std_os_path__path_drop(dir, _ctx);
    kk_box_t _x_x278;
    kk_std_core_types__cctx _x_x279 = kk_std_core_types__cctx_dup(_acc, _ctx); /*ctx<list<std/os/path/path>>*/
    _x_x278 = kk_cctx_apply_linear(_x_x279,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x278, KK_OWNED, _ctx);
  }
}
 
// lifted local: @lift-list-directory@10194, list-directory, @spec-x10126
// specialized: std/core/list/@unroll-map@10010, on parameters @uniq-f@10121, using:
// @uniq-f@10121 = fn<(fsys :: X)>(name: string){
//   val p2@10010 : std/os/path/path;
//   val parts@0@10093 : (list :: V -> V)<string>;
//   val parts@10091 : ? ((list :: V -> V)<string>);
//   std/os/path/Path((match (dir) {
//       ((@skip std/os/path/Path((@x: string) : string, (@pat@0@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@0: std/os/path/path)
//          -> @x;
//     }), (match (parts@10091) {
//       ((std/core/types/@Optional((@uniq-parts@95: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@0: ? ((list :: V -> V)<string>))
//          -> @uniq-parts@95;
//       ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@0: ? ((list :: V -> V)<string>))
//          -> std/core/types/Nil<string>;
//     }));
// }

kk_std_core_types__list kk_std_os_dir__lift_list_directory_10195(kk_std_os_path__path dir_0, kk_std_core_types__list _uniq_xs_10120_0, kk_context_t* _ctx) { /* (dir : std/os/path/path, list<string>) -> fsys list<std/os/path/path> */ 
  kk_std_core_types__cctx _brw_x200 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
  kk_std_core_types__list _brw_x201 = kk_std_os_dir__trmc_lift_list_directory_10195(dir_0, _uniq_xs_10120_0, _brw_x200, _ctx); /*list<std/os/path/path>*/;
  kk_std_core_types__cctx_drop(_brw_x200, _ctx);
  return _brw_x201;
}
 
// lifted local: list-directory, @spec-x10119
// specialized: std/core/list/map, on parameters @uniq-f@10116, using:
// @uniq-f@10116 = fn<(fsys :: X)>(name: string){
//   val p2@10010 : std/os/path/path;
//   val parts@0@10093 : (list :: V -> V)<string>;
//   val parts@10091 : ? ((list :: V -> V)<string>);
//   std/os/path/Path((match (dir) {
//       ((@skip std/os/path/Path((@x: string) : string, (@pat@0@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@0: std/os/path/path)
//          -> @x;
//     }), (match (parts@10091) {
//       ((std/core/types/@Optional((@uniq-parts@95: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@0: ? ((list :: V -> V)<string>))
//          -> @uniq-parts@95;
//       ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@0: ? ((list :: V -> V)<string>))
//          -> std/core/types/Nil<string>;
//     }));
// }

kk_std_core_types__list kk_std_os_dir__lift_list_directory_10194(kk_std_os_path__path dir, kk_std_core_types__list _uniq_xs_10115, kk_context_t* _ctx) { /* (dir : std/os/path/path, list<string>) -> fsys list<std/os/path/path> */ 
  if (kk_std_core_types__is_Nil(_uniq_xs_10115, _ctx)) {
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_std_core_types__cctx _brw_x198 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
    kk_std_core_types__list _brw_x199 = kk_std_os_dir__trmc_lift_list_directory_10195(dir, _uniq_xs_10115, _brw_x198, _ctx); /*list<std/os/path/path>*/;
    kk_std_core_types__cctx_drop(_brw_x198, _ctx);
    return _brw_x199;
  }
}
 
// List directory contents (excluding `.` and `..`).
// Returns a list of full paths (not just the names in the directory).

kk_std_core_types__list kk_std_os_dir_list_directory(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> fsys list<std/os/path/path> */ 
  kk_std_core_exn__error _match_x197;
  kk_string_t _x_x280;
  kk_std_os_path__path _x_x281 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x_x280 = kk_std_os_path_string(_x_x281, _ctx); /*string*/
  _match_x197 = kk_std_os_dir_prim_list_dir(_x_x280, _ctx); /*error<vector<string>>*/
  if (kk_std_core_exn__is_Error(_match_x197, _ctx)) {
    kk_std_core_exn__exception _pat_0 = _match_x197._cons.Error.exception;
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core_exn__error_drop(_match_x197, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_box_t _box_x57 = _match_x197._cons.Ok.result;
    kk_vector_t contents = kk_vector_unbox(_box_x57, _ctx);
    kk_vector_dup(contents, _ctx);
    kk_std_core_exn__error_drop(_match_x197, _ctx);
    kk_std_core_types__list _uniq_xs_10115 = kk_std_core_vector_vlist(contents, kk_std_core_types__new_None(_ctx), _ctx); /*list<string>*/;
    return kk_std_os_dir__lift_list_directory_10194(dir, _uniq_xs_10115, _ctx);
  }
}
 
// lifted local: @lift-list-directory-recursive@10196, list-directory-recursive, @spec-x10141
// specialized: std/core/list/@unroll-filter@10007, on parameters @uniq-pred@10134, using:
// @uniq-pred@10134 = std/os/dir/is-directory

kk_std_core_types__list kk_std_os_dir__trmc_lift_list_directory_recursive_10197(kk_std_core_types__list _uniq_xs_10133, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (list<std/os/path/path>, ctx<list<std/os/path/path>>) -> <fsys,div> list<std/os/path/path> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10133, _ctx)) {
    struct kk_std_core_types_Cons* _con_x282 = kk_std_core_types__as_Cons(_uniq_xs_10133, _ctx);
    kk_box_t _box_x58 = _con_x282->head;
    kk_std_core_types__list _uniq_xx_10137 = _con_x282->tail;
    kk_std_os_path__path _uniq_x_10136 = kk_std_os_path__path_unbox(_box_x58, KK_BORROWED, _ctx);
    kk_reuse_t _ru_x212 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10133, _ctx)) {
      kk_std_os_path__path_dup(_uniq_x_10136, _ctx);
      kk_box_drop(_box_x58, _ctx);
      _ru_x212 = (kk_datatype_ptr_reuse(_uniq_xs_10133, _ctx));
    }
    else {
      kk_std_os_path__path_dup(_uniq_x_10136, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10137, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10133, _ctx);
    }
    bool _match_x196;
    kk_string_t _x_x283;
    kk_std_os_path__path _x_x284 = kk_std_os_path__path_dup(_uniq_x_10136, _ctx); /*std/os/path/path*/
    _x_x283 = kk_std_os_path_string(_x_x284, _ctx); /*string*/
    _match_x196 = kk_std_os_dir_prim_is_dir(_x_x283, _ctx); /*bool*/
    if (_match_x196) {
      kk_std_core_types__list _trmc_x10217 = kk_datatype_null(); /*list<std/os/path/path>*/;
      kk_std_core_types__list _trmc_x10218 = kk_std_core_types__new_Cons(_ru_x212, 0, kk_std_os_path__path_box(_uniq_x_10136, _ctx), _trmc_x10217, _ctx); /*list<std/os/path/path>*/;
      kk_field_addr_t _b_x68_73 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10218, _ctx)->tail, _ctx); /*@field-addr<list<std/os/path/path>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x285 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10218, _ctx)),_b_x68_73,kk_context()); /*ctx<0>*/
        _uniq_xs_10133 = _uniq_xx_10137;
        _acc = _x_x285;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x212,kk_context());
      kk_std_os_path__path_drop(_uniq_x_10136, _ctx);
      { // tailcall
        _uniq_xs_10133 = _uniq_xx_10137;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_box_t _x_x286 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x286, KK_OWNED, _ctx);
  }
}
 
// lifted local: @lift-list-directory-recursive@10196, list-directory-recursive, @spec-x10141
// specialized: std/core/list/@unroll-filter@10007, on parameters @uniq-pred@10134, using:
// @uniq-pred@10134 = std/os/dir/is-directory

kk_std_core_types__list kk_std_os_dir__lift_list_directory_recursive_10197(kk_std_core_types__list _uniq_xs_10133_0, kk_context_t* _ctx) { /* (list<std/os/path/path>) -> <fsys,div> list<std/os/path/path> */ 
  kk_std_core_types__cctx _x_x287 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_os_dir__trmc_lift_list_directory_recursive_10197(_uniq_xs_10133_0, _x_x287, _ctx);
}
 
// lifted local: list-directory-recursive, @spec-x10132
// specialized: std/core/list/filter, on parameters @uniq-pred@10129, using:
// @uniq-pred@10129 = std/os/dir/is-directory

kk_std_core_types__list kk_std_os_dir__lift_list_directory_recursive_10196(kk_std_core_types__list _uniq_xs_10128, kk_context_t* _ctx) { /* (list<std/os/path/path>) -> <fsys,div> list<std/os/path/path> */ 
  if (kk_std_core_types__is_Nil(_uniq_xs_10128, _ctx)) {
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_std_core_types__cctx _x_x288 = kk_cctx_empty(kk_context()); /*ctx<0>*/
    return kk_std_os_dir__trmc_lift_list_directory_recursive_10197(_uniq_xs_10128, _x_x288, _ctx);
  }
}
 
// lifted local: list-directory-recursive, @spec-x10144
// specialized: std/core/list/flatmap, on parameters @uniq-f@10143, using:
// @uniq-f@10143 = fn<<(div :: X),(fsys :: X)>>(sub: std/os/path/path){
//   std/os/dir/list-directory-recursive(sub, (std/core/types/@Optional<int>((std/core/int/int-sub((match (max-depth) {
//         ((std/core/types/@Optional((@uniq-max-depth@436: int) : int) : ? int ) as @pat: ? int)
//            -> @uniq-max-depth@436;
//         ((@skip std/core/types/@None() : ? int ) as @pat@0: ? int)
//            -> 1000;
//       }), 1)))));
// }

kk_std_core_types__list kk_std_os_dir__lift_list_directory_recursive_10198(kk_std_core_types__optional max_depth, kk_std_core_types__list _uniq_xs_10142, kk_context_t* _ctx) { /* (max-depth : ? int, list<std/os/path/path>) -> <div,fsys> list<std/os/path/path> */ 
  return kk_std_os_dir__lift_list_directory_recursive_10199(max_depth, kk_std_core_types__new_Nil(_ctx), _uniq_xs_10142, _ctx);
}
 
// lifted local: @lift-list-directory-recursive@10198, list-directory-recursive, @spec-x10157
// specialized: std/core/list/@lift-flatmap@5433, on parameters @uniq-f@10145, using:
// @uniq-f@10145 = fn<<(div :: X),(fsys :: X)>>(sub: std/os/path/path){
//   std/os/dir/list-directory-recursive(sub, (std/core/types/@Optional<int>((std/core/int/int-sub((match (max-depth) {
//         ((std/core/types/@Optional((@uniq-max-depth@436: int) : int) : ? int ) as @pat: ? int)
//            -> @uniq-max-depth@436;
//         ((@skip std/core/types/@None() : ? int ) as @pat@0: ? int)
//            -> 1000;
//       }), 1)))));
// }

kk_std_core_types__list kk_std_os_dir__lift_list_directory_recursive_10199(kk_std_core_types__optional max_depth, kk_std_core_types__list _uniq_ys_10146, kk_std_core_types__list _uniq_zs_10147, kk_context_t* _ctx) { /* (max-depth : ? int, list<std/os/path/path>, list<std/os/path/path>) -> <div,fsys> list<std/os/path/path> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_ys_10146, _ctx)) {
    struct kk_std_core_types_Cons* _con_x289 = kk_std_core_types__as_Cons(_uniq_ys_10146, _ctx);
    kk_box_t _box_x79 = _con_x289->head;
    kk_std_core_types__list _uniq_yy_10150 = _con_x289->tail;
    kk_std_os_path__path _uniq_y_10149 = kk_std_os_path__path_unbox(_box_x79, KK_BORROWED, _ctx);
    kk_reuse_t _ru_x213 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_ys_10146, _ctx)) {
      kk_std_os_path__path_dup(_uniq_y_10149, _ctx);
      kk_box_drop(_box_x79, _ctx);
      _ru_x213 = (kk_datatype_ptr_reuse(_uniq_ys_10146, _ctx));
    }
    else {
      kk_std_os_path__path_dup(_uniq_y_10149, _ctx);
      kk_std_core_types__list_dup(_uniq_yy_10150, _ctx);
      kk_datatype_ptr_decref(_uniq_ys_10146, _ctx);
    }
    kk_std_core_types__list _b_x81_87 = kk_std_os_dir__lift_list_directory_recursive_10199(max_depth, _uniq_yy_10150, _uniq_zs_10147, _ctx); /*list<std/os/path/path>*/;
    return kk_std_core_types__new_Cons(_ru_x213, 0, kk_std_os_path__path_box(_uniq_y_10149, _ctx), _b_x81_87, _ctx);
  }
  if (kk_std_core_types__is_Cons(_uniq_zs_10147, _ctx)) {
    struct kk_std_core_types_Cons* _con_x290 = kk_std_core_types__as_Cons(_uniq_zs_10147, _ctx);
    kk_box_t _box_x82 = _con_x290->head;
    kk_std_core_types__list _uniq_zz_10154 = _con_x290->tail;
    kk_std_os_path__path _uniq_z_10153 = kk_std_os_path__path_unbox(_box_x82, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_zs_10147, _ctx)) {
      kk_std_os_path__path_dup(_uniq_z_10153, _ctx);
      kk_box_drop(_box_x82, _ctx);
      kk_datatype_ptr_free(_uniq_zs_10147, _ctx);
    }
    else {
      kk_std_os_path__path_dup(_uniq_z_10153, _ctx);
      kk_std_core_types__list_dup(_uniq_zz_10154, _ctx);
      kk_datatype_ptr_decref(_uniq_zs_10147, _ctx);
    }
    kk_integer_t _b_x84_85;
    kk_integer_t _x_x291;
    if (kk_std_core_types__is_Optional(max_depth, _ctx)) {
      kk_box_t _box_x83 = max_depth._cons._Optional.value;
      kk_integer_t _uniq_max_depth_436_0 = kk_integer_unbox(_box_x83, _ctx);
      kk_integer_dup(_uniq_max_depth_436_0, _ctx);
      _x_x291 = _uniq_max_depth_436_0; /*int*/
    }
    else {
      _x_x291 = kk_integer_from_small(1000); /*int*/
    }
    _b_x84_85 = kk_integer_add_small_const(_x_x291, -1, _ctx); /*int*/
    kk_std_core_types__list _uniq_ys_1_10131_10155;
    kk_std_core_types__optional _x_x292 = kk_std_core_types__new_Optional(kk_integer_box(_b_x84_85, _ctx), _ctx); /*? 7*/
    _uniq_ys_1_10131_10155 = kk_std_os_dir_list_directory_recursive(_uniq_z_10153, _x_x292, _ctx); /*list<std/os/path/path>*/
    { // tailcall
      _uniq_ys_10146 = _uniq_ys_1_10131_10155;
      _uniq_zs_10147 = _uniq_zz_10154;
      goto kk__tailcall;
    }
  }
  {
    kk_std_core_types__optional_drop(max_depth, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
}
 
// Recursively list all the entries under a directory.

kk_std_core_types__list kk_std_os_dir_list_directory_recursive(kk_std_os_path__path dir, kk_std_core_types__optional max_depth_0, kk_context_t* _ctx) { /* (dir : std/os/path/path, max-depth : ? int) -> <div,fsys> list<std/os/path/path> */ 
  bool _match_x193;
  kk_integer_t _brw_x194;
  if (kk_std_core_types__is_Optional(max_depth_0, _ctx)) {
    kk_box_t _box_x88 = max_depth_0._cons._Optional.value;
    kk_integer_t _uniq_max_depth_436 = kk_integer_unbox(_box_x88, _ctx);
    kk_integer_dup(_uniq_max_depth_436, _ctx);
    _brw_x194 = _uniq_max_depth_436; /*int*/
  }
  else {
    _brw_x194 = kk_integer_from_small(1000); /*int*/
  }
  bool _brw_x195 = kk_integer_lt_borrow(_brw_x194,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_x194, _ctx);
  _match_x193 = _brw_x195; /*bool*/
  if (_match_x193) {
    kk_std_core_types__optional_drop(max_depth_0, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_std_core_types__list all = kk_std_os_dir_list_directory(dir, _ctx); /*list<std/os/path/path>*/;
    kk_std_core_types__list dirs;
    kk_std_core_types__list _x_x293 = kk_std_core_types__list_dup(all, _ctx); /*list<std/os/path/path>*/
    dirs = kk_std_os_dir__lift_list_directory_recursive_10196(_x_x293, _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__list ys_10012 = kk_std_os_dir__lift_list_directory_recursive_10198(max_depth_0, dirs, _ctx); /*list<std/os/path/path>*/;
    if (kk_std_core_types__is_Nil(all, _ctx)) {
      return ys_10012;
    }
    {
      return kk_std_core_list__unroll_append_10004(all, ys_10012, _ctx);
    }
  }
}
 
// lifted local: copy-directory, @spec-x10165
// specialized: std/core/list/partition, on parameters @uniq-pred@10160, using:
// @uniq-pred@10160 = std/core/types/@open<(fsys :: X),<(fsys :: X),(div :: X),(exn :: (E, V) -> V)>,(dir : std/os/path/path) -> (fsys :: X) bool,(dir : std/os/path/path) -> <(fsys :: X),(div :: X),(exn :: (E, V) -> V)> bool>(std/os/dir/is-directory)


// lift anonymous function
struct kk_std_os_dir__lift_copy_directory_10200_fun296__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__lift_copy_directory_10200_fun296(kk_function_t _fself, kk_box_t _b_x102, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift_copy_directory_10200_fun296(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__lift_copy_directory_10200_fun296, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_os_dir__lift_copy_directory_10200_fun298__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__lift_copy_directory_10200_fun298(kk_function_t _fself, kk_box_t _b_x97, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift_copy_directory_10200_fun298(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__lift_copy_directory_10200_fun298, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__lift_copy_directory_10200_fun298(kk_function_t _fself, kk_box_t _b_x97, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  bool _x_x299;
  kk_std_os_path__path _x_x300 = kk_std_os_path__path_unbox(_b_x97, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x299 = kk_std_os_dir_is_directory(_x_x300, _ctx); /*bool*/
  return kk_bool_box(_x_x299);
}
static bool kk_std_os_dir__lift_copy_directory_10200_fun296(kk_function_t _fself, kk_box_t _b_x102, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_box_t _x_x297 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_lift_copy_directory_10200_fun298(_ctx), _b_x102, _ctx); /*9586*/
  return kk_bool_unbox(_x_x297);
}

kk_std_core_types__tuple2 kk_std_os_dir__lift_copy_directory_10200(kk_std_core_types__list _uniq_xs_10159, kk_context_t* _ctx) { /* (list<std/os/path/path>) -> <fsys,div,exn> (list<std/os/path/path>, list<std/os/path/path>) */ 
  kk_std_core_types__cctx _uniq_acc1_10094_10161 = kk_cctx_empty(kk_context()); /*ctx<list<std/os/path/path>>*/;
  kk_std_core_types__cctx _uniq_acc2_10095_10162 = kk_cctx_empty(kk_context()); /*ctx<list<std/os/path/path>>*/;
  if (kk_std_core_types__is_Nil(_uniq_xs_10159, _ctx)) {
    kk_std_core_types__list _b_x93_103;
    kk_box_t _x_x294 = kk_cctx_apply(_uniq_acc1_10094_10161,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x93_103 = kk_std_core_types__list_unbox(_x_x294, KK_OWNED, _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__list _b_x94_104;
    kk_box_t _x_x295 = kk_cctx_apply(_uniq_acc2_10095_10162,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x94_104 = kk_std_core_types__list_unbox(_x_x295, KK_OWNED, _ctx); /*list<std/os/path/path>*/
    return kk_std_core_types__new_Tuple2(kk_std_core_types__list_box(_b_x93_103, _ctx), kk_std_core_types__list_box(_b_x94_104, _ctx), _ctx);
  }
  {
    kk_function_t _brw_x191 = kk_std_os_dir__new_lift_copy_directory_10200_fun296(_ctx); /*(2566) -> 2567 bool*/;
    kk_std_core_types__tuple2 _brw_x192 = kk_std_core_list__unroll_partition_acc_10014(_uniq_xs_10159, _brw_x191, _uniq_acc1_10094_10161, _uniq_acc2_10095_10162, _ctx); /*(list<2566>, list<2566>)*/;
    kk_function_drop(_brw_x191, _ctx);
    return _brw_x192;
  }
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift_lift_copy_directory_10202_10284(kk_std_core_types__list _uniq_xx_10175, kk_std_os_path__path to, kk_unit_t _uniq_x___10176, kk_context_t* _ctx) { /* (list<std/os/path/path>, to : std/os/path/path, ()) -> <exn,fsys> () */ 
  kk_std_os_dir__lift_copy_directory_10202(to, _uniq_xx_10175, _ctx); return kk_Unit;
}
 
// lifted local: @lift-copy-directory@10201, copy-directory, @spec-x10178
// specialized: std/core/list/@unroll-foreach@10016, on parameters @uniq-action@10172, using:
// @uniq-action@10172 = fn<<(exn :: (E, V) -> V),(fsys :: X),(div :: X)>>(f: std/os/path/path){
//   std/os/dir/copy-file(f, (std/core/types/@open<(total :: E),<(exn :: (E, V) -> V),(fsys :: X),(div :: X)>,(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path,(p1 : std/os/path/path, p2 : std/os/path/path) -> <(exn :: (E, V) -> V),(fsys :: X),(div :: X)> std/os/path/path>((fn(p1: std/os/path/path, p2: std/os/path/path){
//       val parts@0@10093 : ((list :: V -> V)<string>);
//       val parts@10091 : ? ((list :: V -> V)<string>);
//       (std/os/path/Path((match (p1) {
//           ((@skip std/os/path/Path((@x: string) : string, (@pat@0@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3: std/os/path/path)
//              -> @x;
//         }), (match (parts@10091) {
//           ((std/core/types/@Optional((@uniq-parts@95: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1: ? ((list :: V -> V)<string>))
//              -> @uniq-parts@95;
//           ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2: ? ((list :: V -> V)<string>))
//              -> std/core/types/Nil<string>;
//         })));
//     }))(to, (std/core/types/@open<(total :: E),<(exn :: (E, V) -> V),(fsys :: X),(div :: X)>,(p : std/os/path/path) -> std/os/path/path,(p : std/os/path/path) -> <(exn :: (E, V) -> V),(fsys :: X),(div :: X)> std/os/path/path>((fn(p: std/os/path/path){
//         val parts@10122 : ? ((list :: V -> V)<string>)
//               = (std/core/types/@Optional<(list :: V -> V)<string>>((std/core/list/take<string>((match (p) {
//                   ((@skip std/os/path/Path((@pat@0@3@1: string) : string, (@x@1@1: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@5@0: std/os/path/path)
//                      -> @x@1@1;
//                 }), 1))));
//         (std/os/path/Path("", (match (parts@10122) {
//             ((std/core/types/@Optional((@uniq-parts@133: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@0: ? ((list :: V -> V)<string>))
//                -> @uniq-parts@133;
//             ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@0: ? ((list :: V -> V)<string>))
//                -> (match (p) {
//                 ((@skip std/os/path/Path((@pat@0@1@0: string) : string, (@x@0@1: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@0: std/os/path/path)
//                    -> @x@0@1;
//               });
//           })));
//       }))(f)))), (std/core/types/@None<bool>));
// }


// lift anonymous function
struct kk_std_os_dir__lift_copy_directory_10202_fun312__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10175_0;
  kk_std_os_path__path to_0;
};
static kk_box_t kk_std_os_dir__lift_copy_directory_10202_fun312(kk_function_t _fself, kk_box_t _b_x124, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift_copy_directory_10202_fun312(kk_std_core_types__list _uniq_xx_10175_0, kk_std_os_path__path to_0, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift_copy_directory_10202_fun312__t* _self = kk_function_alloc_as(struct kk_std_os_dir__lift_copy_directory_10202_fun312__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__lift_copy_directory_10202_fun312, kk_context());
  _self->_uniq_xx_10175_0 = _uniq_xx_10175_0;
  _self->to_0 = to_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__lift_copy_directory_10202_fun312(kk_function_t _fself, kk_box_t _b_x124, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift_copy_directory_10202_fun312__t* _self = kk_function_as(struct kk_std_os_dir__lift_copy_directory_10202_fun312__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10175_0 = _self->_uniq_xx_10175_0; /* list<std/os/path/path> */
  kk_std_os_path__path to_0 = _self->to_0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10175_0, _ctx);kk_std_os_path__path_dup(to_0, _ctx);}, {}, _ctx)
  kk_unit_t _uniq_x___10176_0_126 = kk_Unit;
  kk_unit_unbox(_b_x124);
  kk_unit_t _x_x313 = kk_Unit;
  kk_std_os_dir__mlift_lift_copy_directory_10202_10284(_uniq_xx_10175_0, to_0, _uniq_x___10176_0_126, _ctx);
  return kk_unit_box(_x_x313);
}

kk_unit_t kk_std_os_dir__lift_copy_directory_10202(kk_std_os_path__path to_0, kk_std_core_types__list _uniq_xs_10171, kk_context_t* _ctx) { /* (to : std/os/path/path, list<std/os/path/path>) -> <exn,fsys,div> () */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10171, _ctx)) {
    struct kk_std_core_types_Cons* _con_x301 = kk_std_core_types__as_Cons(_uniq_xs_10171, _ctx);
    kk_box_t _box_x116 = _con_x301->head;
    kk_std_core_types__list _uniq_xx_10175_0 = _con_x301->tail;
    kk_std_os_path__path _uniq_x_10174 = kk_std_os_path__path_unbox(_box_x116, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10171, _ctx)) {
      kk_std_os_path__path_dup(_uniq_x_10174, _ctx);
      kk_box_drop(_box_x116, _ctx);
      kk_datatype_ptr_free(_uniq_xs_10171, _ctx);
    }
    else {
      kk_std_os_path__path_dup(_uniq_x_10174, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10175_0, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10171, _ctx);
    }
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys,div>>*/;
    kk_std_core_types__list _b_x117_118;
    kk_std_core_types__list _x_x302;
    {
      kk_std_core_types__list _x_1_1 = _uniq_x_10174.parts;
      kk_std_core_types__list_dup(_x_1_1, _ctx);
      _x_x302 = _x_1_1; /*list<string>*/
    }
    _b_x117_118 = kk_std_core_list_take(_x_x302, kk_integer_from_small(1), _ctx); /*list<string>*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_evv_t w_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys,div>>*/;
    kk_std_os_path__path p2;
    kk_string_t _x_x303 = kk_string_empty(); /*string*/
    kk_std_core_types__list _x_x305;
    kk_std_core_types__optional _match_x190 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x117_118, _ctx), _ctx); /*? 7*/;
    if (kk_std_core_types__is_Optional(_match_x190, _ctx)) {
      kk_box_t _box_x119 = _match_x190._cons._Optional.value;
      kk_std_core_types__list _uniq_parts_133 = kk_std_core_types__list_unbox(_box_x119, KK_BORROWED, _ctx);
      kk_std_core_types__list_dup(_uniq_parts_133, _ctx);
      kk_std_core_types__optional_drop(_match_x190, _ctx);
      _x_x305 = _uniq_parts_133; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x190, _ctx);
      {
        kk_std_core_types__list _x_0_1 = _uniq_x_10174.parts;
        kk_std_core_types__list_dup(_x_0_1, _ctx);
        _x_x305 = _x_0_1; /*list<string>*/
      }
    }
    p2 = kk_std_os_path__new_Path(_x_x303, _x_x305, _ctx); /*std/os/path/path*/
    kk_std_core_types__list parts_0_10093;
    {
      kk_std_core_types__list _x_0 = p2.parts;
      kk_std_core_types__list_dup(_x_0, _ctx);
      if (kk_std_core_types__is_Nil(_x_0, _ctx)) {
        kk_std_os_path__path_drop(p2, _ctx);
        parts_0_10093 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
      }
      else {
        kk_std_core_types__list_drop(_x_0, _ctx);
        kk_std_core_types__list _x_x306;
        {
          kk_std_core_types__list _x_0_0 = p2.parts;
          kk_std_core_types__list_dup(_x_0_0, _ctx);
          kk_std_os_path__path_drop(p2, _ctx);
          _x_x306 = _x_0_0; /*list<string>*/
        }
        parts_0_10093 = kk_std_core_list__unroll_reverse_acc_10003(kk_std_core_types__new_Nil(_ctx), _x_x306, _ctx); /*list<string>*/
      }
    }
    kk_std_core_types__list _b_x120_121;
    if (kk_std_core_types__is_Nil(parts_0_10093, _ctx)) {
      kk_std_core_types__list _x_1 = to_0.parts;
      kk_std_core_types__list_dup(_x_1, _ctx);
      _b_x120_121 = _x_1; /*list<string>*/
    }
    else {
      kk_std_core_types__list _x_x307;
      {
        kk_std_core_types__list _x_1_0 = to_0.parts;
        kk_std_core_types__list_dup(_x_1_0, _ctx);
        _x_x307 = _x_1_0; /*list<string>*/
      }
      _b_x120_121 = kk_std_os_path__unroll_push_parts_10000(parts_0_10093, _x_x307, _ctx); /*list<string>*/
    }
    kk_unit_t keep_0 = kk_Unit;
    kk_evv_set(w_0,kk_context());
    kk_unit_t x_0_10318 = kk_Unit;
    kk_std_os_path__path _x_x308;
    kk_string_t _x_x309;
    {
      kk_string_t _x = to_0.root;
      kk_string_dup(_x, _ctx);
      _x_x309 = _x; /*string*/
    }
    kk_std_core_types__list _x_x310;
    kk_std_core_types__optional _match_x189 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x120_121, _ctx), _ctx); /*? 7*/;
    if (kk_std_core_types__is_Optional(_match_x189, _ctx)) {
      kk_box_t _box_x122 = _match_x189._cons._Optional.value;
      kk_std_core_types__list _uniq_parts_95 = kk_std_core_types__list_unbox(_box_x122, KK_BORROWED, _ctx);
      kk_std_core_types__list_dup(_uniq_parts_95, _ctx);
      kk_std_core_types__optional_drop(_match_x189, _ctx);
      _x_x310 = _uniq_parts_95; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x189, _ctx);
      _x_x310 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
    }
    _x_x308 = kk_std_os_path__new_Path(_x_x309, _x_x310, _ctx); /*std/os/path/path*/
    kk_std_os_dir_copy_file(_uniq_x_10174, _x_x308, kk_std_core_types__new_None(_ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x311 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_lift_copy_directory_10202_fun312(_uniq_xx_10175_0, to_0, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x311); return kk_Unit;
    }
    { // tailcall
      _uniq_xs_10171 = _uniq_xx_10175_0;
      goto kk__tailcall;
    }
  }
  {
    kk_std_os_path__path_drop(to_0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// lifted local: copy-directory, @spec-x10170
// specialized: std/core/list/foreach, on parameters @uniq-action@10167, using:
// @uniq-action@10167 = fn<<(exn :: (E, V) -> V),(fsys :: X),(div :: X)>>(f: std/os/path/path){
//   std/os/dir/copy-file(f, (std/core/types/@open<(total :: E),<(exn :: (E, V) -> V),(fsys :: X),(div :: X)>,(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path,(p1 : std/os/path/path, p2 : std/os/path/path) -> <(exn :: (E, V) -> V),(fsys :: X),(div :: X)> std/os/path/path>((fn(p1: std/os/path/path, p2: std/os/path/path){
//       val parts@0@10093 : ((list :: V -> V)<string>);
//       val parts@10091 : ? ((list :: V -> V)<string>);
//       (std/os/path/Path((match (p1) {
//           ((@skip std/os/path/Path((@x: string) : string, (@pat@0@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3: std/os/path/path)
//              -> @x;
//         }), (match (parts@10091) {
//           ((std/core/types/@Optional((@uniq-parts@95: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1: ? ((list :: V -> V)<string>))
//              -> @uniq-parts@95;
//           ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2: ? ((list :: V -> V)<string>))
//              -> std/core/types/Nil<string>;
//         })));
//     }))(to, (std/core/types/@open<(total :: E),<(exn :: (E, V) -> V),(fsys :: X),(div :: X)>,(p : std/os/path/path) -> std/os/path/path,(p : std/os/path/path) -> <(exn :: (E, V) -> V),(fsys :: X),(div :: X)> std/os/path/path>((fn(p: std/os/path/path){
//         val parts@10122 : ? ((list :: V -> V)<string>)
//               = (std/core/types/@Optional<(list :: V -> V)<string>>((std/core/list/take<string>((match (p) {
//                   ((@skip std/os/path/Path((@pat@0@3@1: string) : string, (@x@1@1: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@5@0: std/os/path/path)
//                      -> @x@1@1;
//                 }), 1))));
//         (std/os/path/Path("", (match (parts@10122) {
//             ((std/core/types/@Optional((@uniq-parts@133: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@0: ? ((list :: V -> V)<string>))
//                -> @uniq-parts@133;
//             ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@0: ? ((list :: V -> V)<string>))
//                -> (match (p) {
//                 ((@skip std/os/path/Path((@pat@0@1@0: string) : string, (@x@0@1: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@0: std/os/path/path)
//                    -> @x@0@1;
//               });
//           })));
//       }))(f)))), (std/core/types/@None<bool>));
// }

kk_unit_t kk_std_os_dir__lift_copy_directory_10201(kk_std_os_path__path to, kk_std_core_types__list _uniq_xs_10166, kk_context_t* _ctx) { /* (to : std/os/path/path, list<std/os/path/path>) -> <exn,fsys,div> () */ 
  if (kk_std_core_types__is_Nil(_uniq_xs_10166, _ctx)) {
    kk_std_os_path__path_drop(to, _ctx);
    kk_Unit; return kk_Unit;
  }
  {
    kk_std_os_dir__lift_copy_directory_10202(to, _uniq_xs_10166, _ctx); return kk_Unit;
  }
}
 
// lifted local: copy-directory, @spec-x10184
// specialized: std/core/list/foreach, on parameters @uniq-action@10181, using:
// @uniq-action@10181 = fn<<(div :: X),(exn :: (E, V) -> V),(fsys :: X)>>(d: std/os/path/path){
//   std/os/dir/copy-directory(d, (std/core/types/@open<(total :: E),<(div :: X),(exn :: (E, V) -> V),(fsys :: X)>,(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path,(p1 : std/os/path/path, p2 : std/os/path/path) -> <(div :: X),(exn :: (E, V) -> V),(fsys :: X)> std/os/path/path>((fn(p1@0: std/os/path/path, p2@0: std/os/path/path){
//       val parts@0@10093@0 : ((list :: V -> V)<string>);
//       val parts@10091@0 : ? ((list :: V -> V)<string>);
//       (std/os/path/Path((match (p1@0) {
//           ((@skip std/os/path/Path((@x@2: string) : string, (@pat@0@0@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@1: std/os/path/path)
//              -> @x@2;
//         }), (match (parts@10091@0) {
//           ((std/core/types/@Optional((@uniq-parts@95@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@1: ? ((list :: V -> V)<string>))
//              -> @uniq-parts@95@0;
//           ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@1: ? ((list :: V -> V)<string>))
//              -> std/core/types/Nil<string>;
//         })));
//     }))(to, (std/core/types/@open<(total :: E),<(div :: X),(exn :: (E, V) -> V),(fsys :: X)>,(p : std/os/path/path) -> std/os/path/path,(p : std/os/path/path) -> <(div :: X),(exn :: (E, V) -> V),(fsys :: X)> std/os/path/path>((fn(p@0: std/os/path/path){
//         val parts@10122@0 : ? ((list :: V -> V)<string>)
//               = (std/core/types/@Optional<(list :: V -> V)<string>>((std/core/list/take<string>((match (p@0) {
//                   ((@skip std/os/path/Path((@pat@0@3@3: string) : string, (@x@1@3: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@5@2: std/os/path/path)
//                      -> @x@1@3;
//                 }), 1))));
//         (std/os/path/Path("", (match (parts@10122@0) {
//             ((std/core/types/@Optional((@uniq-parts@133@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@0@0: ? ((list :: V -> V)<string>))
//                -> @uniq-parts@133@0;
//             ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@2: ? ((list :: V -> V)<string>))
//                -> (match (p@0) {
//                 ((@skip std/os/path/Path((@pat@0@1@2: string) : string, (@x@0@3: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@2: std/os/path/path)
//                    -> @x@0@3;
//               });
//           })));
//       }))(d)))));
// }

kk_unit_t kk_std_os_dir__lift_copy_directory_10203(kk_std_os_path__path to, kk_std_core_types__list _uniq_xs_10180, kk_context_t* _ctx) { /* (to : std/os/path/path, list<std/os/path/path>) -> <div,exn,fsys> () */ 
  if (kk_std_core_types__is_Nil(_uniq_xs_10180, _ctx)) {
    kk_std_os_path__path_drop(to, _ctx);
    kk_Unit; return kk_Unit;
  }
  {
    kk_std_os_dir__lift_copy_directory_10204(to, _uniq_xs_10180, _ctx); return kk_Unit;
  }
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift_lift_copy_directory_10204_10285(kk_std_core_types__list _uniq_xx_10189, kk_std_os_path__path to, kk_unit_t _uniq_x___10190, kk_context_t* _ctx) { /* (list<std/os/path/path>, to : std/os/path/path, ()) -> <pure,fsys> () */ 
  kk_std_os_dir__lift_copy_directory_10204(to, _uniq_xx_10189, _ctx); return kk_Unit;
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift_copy_directory_10286(kk_std_core_types__list dirs, kk_std_os_path__path to_0, kk_unit_t wild___0, kk_context_t* _ctx) { /* (dirs : list<std/os/path/path>, to : std/os/path/path, wild_@0 : ()) -> <exn,fsys,div> () */ 
  kk_std_os_dir__lift_copy_directory_10203(to_0, dirs, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10287_fun316__t {
  struct kk_function_s _base;
  kk_std_core_types__list dirs_0;
  kk_std_os_path__path to_1;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10287_fun316(kk_function_t _fself, kk_box_t _b_x130, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10287_fun316(kk_std_core_types__list dirs_0, kk_std_os_path__path to_1, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10287_fun316__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10287_fun316__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10287_fun316, kk_context());
  _self->dirs_0 = dirs_0;
  _self->to_1 = to_1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10287_fun316(kk_function_t _fself, kk_box_t _b_x130, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10287_fun316__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10287_fun316__t*, _fself, _ctx);
  kk_std_core_types__list dirs_0 = _self->dirs_0; /* list<std/os/path/path> */
  kk_std_os_path__path to_1 = _self->to_1; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core_types__list_dup(dirs_0, _ctx);kk_std_os_path__path_dup(to_1, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_0_132 = kk_Unit;
  kk_unit_unbox(_b_x130);
  kk_unit_t _x_x317 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10286(dirs_0, to_1, wild___0_0_132, _ctx);
  return kk_unit_box(_x_x317);
}

kk_unit_t kk_std_os_dir__mlift_copy_directory_10287(kk_std_os_path__path to_1, kk_std_core_types__tuple2 _y_x10236, kk_context_t* _ctx) { /* (to : std/os/path/path, (list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */ 
  {
    kk_box_t _box_x127 = _y_x10236.fst;
    kk_box_t _box_x128 = _y_x10236.snd;
    kk_std_core_types__list dirs_0 = kk_std_core_types__list_unbox(_box_x127, KK_BORROWED, _ctx);
    kk_std_core_types__list files = kk_std_core_types__list_unbox(_box_x128, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(dirs_0, _ctx);
    kk_std_core_types__list_dup(files, _ctx);
    kk_std_core_types__tuple2_drop(_y_x10236, _ctx);
    kk_unit_t x_10324 = kk_Unit;
    kk_std_os_path__path _x_x314 = kk_std_os_path__path_dup(to_1, _ctx); /*std/os/path/path*/
    kk_std_os_dir__lift_copy_directory_10201(_x_x314, files, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x315 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift_copy_directory_10287_fun316(dirs_0, to_1, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x315); return kk_Unit;
    }
    {
      kk_std_os_dir__mlift_copy_directory_10286(dirs_0, to_1, x_10324, _ctx); return kk_Unit;
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10288_fun319__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10288_fun319(kk_function_t _fself, kk_box_t _b_x135, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10288_fun319(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10288_fun319, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10288_fun319(kk_function_t _fself, kk_box_t _b_x135, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _x_x320;
  kk_std_os_path__path _x_x321 = kk_std_os_path__path_unbox(_b_x135, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x320 = kk_std_os_dir_list_directory(_x_x321, _ctx); /*list<std/os/path/path>*/
  return kk_std_core_types__list_box(_x_x320, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10288_fun323__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_2;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10288_fun323(kk_function_t _fself, kk_box_t _b_x139, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10288_fun323(kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10288_fun323__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10288_fun323__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10288_fun323, kk_context());
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10288_fun323(kk_function_t _fself, kk_box_t _b_x139, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10288_fun323__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10288_fun323__t*, _fself, _ctx);
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2 _y_x10236_0_141 = kk_std_core_types__tuple2_unbox(_b_x139, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x_x324 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10287(to_2, _y_x10236_0_141, _ctx);
  return kk_unit_box(_x_x324);
}

kk_unit_t kk_std_os_dir__mlift_copy_directory_10288(kk_std_os_path__path dir, kk_std_os_path__path to_2, kk_unit_t wild__, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path, wild_ : ()) -> <exn,fsys> () */ 
  kk_std_core_types__list all;
  kk_box_t _x_x318 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10288_fun319(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*9586*/
  all = kk_std_core_types__list_unbox(_x_x318, KK_OWNED, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2 x_0_10326 = kk_std_os_dir__lift_copy_directory_10200(all, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2_drop(x_0_10326, _ctx);
    kk_box_t _x_x322 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift_copy_directory_10288_fun323(to_2, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x322); return kk_Unit;
  }
  {
    kk_std_os_dir__mlift_copy_directory_10287(to_2, x_0_10326, _ctx); return kk_Unit;
  }
}
 
// lifted local: @lift-copy-directory@10203, copy-directory, @spec-x10192
// specialized: std/core/list/@unroll-foreach@10016, on parameters @uniq-action@10186, using:
// @uniq-action@10186 = fn<<(div :: X),(exn :: (E, V) -> V),(fsys :: X)>>(d: std/os/path/path){
//   std/os/dir/copy-directory(d, (std/core/types/@open<(total :: E),<(div :: X),(exn :: (E, V) -> V),(fsys :: X)>,(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path,(p1 : std/os/path/path, p2 : std/os/path/path) -> <(div :: X),(exn :: (E, V) -> V),(fsys :: X)> std/os/path/path>((fn(p1@0: std/os/path/path, p2@0: std/os/path/path){
//       val parts@0@10093@0 : ((list :: V -> V)<string>);
//       val parts@10091@0 : ? ((list :: V -> V)<string>);
//       (std/os/path/Path((match (p1@0) {
//           ((@skip std/os/path/Path((@x@2: string) : string, (@pat@0@0@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@1: std/os/path/path)
//              -> @x@2;
//         }), (match (parts@10091@0) {
//           ((std/core/types/@Optional((@uniq-parts@95@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@1: ? ((list :: V -> V)<string>))
//              -> @uniq-parts@95@0;
//           ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@1: ? ((list :: V -> V)<string>))
//              -> std/core/types/Nil<string>;
//         })));
//     }))(to, (std/core/types/@open<(total :: E),<(div :: X),(exn :: (E, V) -> V),(fsys :: X)>,(p : std/os/path/path) -> std/os/path/path,(p : std/os/path/path) -> <(div :: X),(exn :: (E, V) -> V),(fsys :: X)> std/os/path/path>((fn(p@0: std/os/path/path){
//         val parts@10122@0 : ? ((list :: V -> V)<string>)
//               = (std/core/types/@Optional<(list :: V -> V)<string>>((std/core/list/take<string>((match (p@0) {
//                   ((@skip std/os/path/Path((@pat@0@3@3: string) : string, (@x@1@3: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@5@2: std/os/path/path)
//                      -> @x@1@3;
//                 }), 1))));
//         (std/os/path/Path("", (match (parts@10122@0) {
//             ((std/core/types/@Optional((@uniq-parts@133@0: (list :: V -> V)<string>) : (list :: V -> V)<string>) : ? ((list :: V -> V)<string>) ) as @pat@1@0@0: ? ((list :: V -> V)<string>))
//                -> @uniq-parts@133@0;
//             ((@skip std/core/types/@None() : ? ((list :: V -> V)<string>) ) as @pat@2@2: ? ((list :: V -> V)<string>))
//                -> (match (p@0) {
//                 ((@skip std/os/path/Path((@pat@0@1@2: string) : string, (@x@0@3: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as @pat@3@2: std/os/path/path)
//                    -> @x@0@3;
//               });
//           })));
//       }))(d)))));
// }


// lift anonymous function
struct kk_std_os_dir__lift_copy_directory_10204_fun336__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10189_0;
  kk_std_os_path__path to_3;
};
static kk_box_t kk_std_os_dir__lift_copy_directory_10204_fun336(kk_function_t _fself, kk_box_t _b_x150, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift_copy_directory_10204_fun336(kk_std_core_types__list _uniq_xx_10189_0, kk_std_os_path__path to_3, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift_copy_directory_10204_fun336__t* _self = kk_function_alloc_as(struct kk_std_os_dir__lift_copy_directory_10204_fun336__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__lift_copy_directory_10204_fun336, kk_context());
  _self->_uniq_xx_10189_0 = _uniq_xx_10189_0;
  _self->to_3 = to_3;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__lift_copy_directory_10204_fun336(kk_function_t _fself, kk_box_t _b_x150, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift_copy_directory_10204_fun336__t* _self = kk_function_as(struct kk_std_os_dir__lift_copy_directory_10204_fun336__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10189_0 = _self->_uniq_xx_10189_0; /* list<std/os/path/path> */
  kk_std_os_path__path to_3 = _self->to_3; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10189_0, _ctx);kk_std_os_path__path_dup(to_3, _ctx);}, {}, _ctx)
  kk_unit_t _uniq_x___10190_0_152 = kk_Unit;
  kk_unit_unbox(_b_x150);
  kk_unit_t _x_x337 = kk_Unit;
  kk_std_os_dir__mlift_lift_copy_directory_10204_10285(_uniq_xx_10189_0, to_3, _uniq_x___10190_0_152, _ctx);
  return kk_unit_box(_x_x337);
}

kk_unit_t kk_std_os_dir__lift_copy_directory_10204(kk_std_os_path__path to_3, kk_std_core_types__list _uniq_xs_10185, kk_context_t* _ctx) { /* (to : std/os/path/path, list<std/os/path/path>) -> <div,exn,fsys> () */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10185, _ctx)) {
    struct kk_std_core_types_Cons* _con_x325 = kk_std_core_types__as_Cons(_uniq_xs_10185, _ctx);
    kk_box_t _box_x142 = _con_x325->head;
    kk_std_core_types__list _uniq_xx_10189_0 = _con_x325->tail;
    kk_std_os_path__path _uniq_x_10188 = kk_std_os_path__path_unbox(_box_x142, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10185, _ctx)) {
      kk_std_os_path__path_dup(_uniq_x_10188, _ctx);
      kk_box_drop(_box_x142, _ctx);
      kk_datatype_ptr_free(_uniq_xs_10185, _ctx);
    }
    else {
      kk_std_os_path__path_dup(_uniq_x_10188, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10189_0, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10185, _ctx);
    }
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<div,exn,fsys>>*/;
    kk_std_core_types__list _b_x143_144;
    kk_std_core_types__list _x_x326;
    {
      kk_std_core_types__list _x_1_3 = _uniq_x_10188.parts;
      kk_std_core_types__list_dup(_x_1_3, _ctx);
      _x_x326 = _x_1_3; /*list<string>*/
    }
    _b_x143_144 = kk_std_core_list_take(_x_x326, kk_integer_from_small(1), _ctx); /*list<string>*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_evv_t w_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<div,exn,fsys>>*/;
    kk_std_os_path__path p2_0;
    kk_string_t _x_x327 = kk_string_empty(); /*string*/
    kk_std_core_types__list _x_x329;
    kk_std_core_types__optional _match_x185 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x143_144, _ctx), _ctx); /*? 7*/;
    if (kk_std_core_types__is_Optional(_match_x185, _ctx)) {
      kk_box_t _box_x145 = _match_x185._cons._Optional.value;
      kk_std_core_types__list _uniq_parts_133_0 = kk_std_core_types__list_unbox(_box_x145, KK_BORROWED, _ctx);
      kk_std_core_types__list_dup(_uniq_parts_133_0, _ctx);
      kk_std_core_types__optional_drop(_match_x185, _ctx);
      _x_x329 = _uniq_parts_133_0; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x185, _ctx);
      {
        kk_std_core_types__list _x_0_3 = _uniq_x_10188.parts;
        kk_std_core_types__list_dup(_x_0_3, _ctx);
        _x_x329 = _x_0_3; /*list<string>*/
      }
    }
    p2_0 = kk_std_os_path__new_Path(_x_x327, _x_x329, _ctx); /*std/os/path/path*/
    kk_std_core_types__list parts_0_10093_0;
    {
      kk_std_core_types__list _x_0_2 = p2_0.parts;
      kk_std_core_types__list_dup(_x_0_2, _ctx);
      if (kk_std_core_types__is_Nil(_x_0_2, _ctx)) {
        kk_std_os_path__path_drop(p2_0, _ctx);
        parts_0_10093_0 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
      }
      else {
        kk_std_core_types__list_drop(_x_0_2, _ctx);
        kk_std_core_types__list _x_x330;
        {
          kk_std_core_types__list _x_0_0_0 = p2_0.parts;
          kk_std_core_types__list_dup(_x_0_0_0, _ctx);
          kk_std_os_path__path_drop(p2_0, _ctx);
          _x_x330 = _x_0_0_0; /*list<string>*/
        }
        parts_0_10093_0 = kk_std_core_list__unroll_reverse_acc_10003(kk_std_core_types__new_Nil(_ctx), _x_x330, _ctx); /*list<string>*/
      }
    }
    kk_std_core_types__list _b_x146_147;
    if (kk_std_core_types__is_Nil(parts_0_10093_0, _ctx)) {
      kk_std_core_types__list _x_1_2 = to_3.parts;
      kk_std_core_types__list_dup(_x_1_2, _ctx);
      _b_x146_147 = _x_1_2; /*list<string>*/
    }
    else {
      kk_std_core_types__list _x_x331;
      {
        kk_std_core_types__list _x_1_0_0 = to_3.parts;
        kk_std_core_types__list_dup(_x_1_0_0, _ctx);
        _x_x331 = _x_1_0_0; /*list<string>*/
      }
      _b_x146_147 = kk_std_os_path__unroll_push_parts_10000(parts_0_10093_0, _x_x331, _ctx); /*list<string>*/
    }
    kk_unit_t keep_0 = kk_Unit;
    kk_evv_set(w_0,kk_context());
    kk_unit_t x_2_10330 = kk_Unit;
    kk_std_os_path__path _x_x332;
    kk_string_t _x_x333;
    {
      kk_string_t _x_2 = to_3.root;
      kk_string_dup(_x_2, _ctx);
      _x_x333 = _x_2; /*string*/
    }
    kk_std_core_types__list _x_x334;
    kk_std_core_types__optional _match_x184 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x146_147, _ctx), _ctx); /*? 7*/;
    if (kk_std_core_types__is_Optional(_match_x184, _ctx)) {
      kk_box_t _box_x148 = _match_x184._cons._Optional.value;
      kk_std_core_types__list _uniq_parts_95_0 = kk_std_core_types__list_unbox(_box_x148, KK_BORROWED, _ctx);
      kk_std_core_types__list_dup(_uniq_parts_95_0, _ctx);
      kk_std_core_types__optional_drop(_match_x184, _ctx);
      _x_x334 = _uniq_parts_95_0; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x184, _ctx);
      _x_x334 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
    }
    _x_x332 = kk_std_os_path__new_Path(_x_x333, _x_x334, _ctx); /*std/os/path/path*/
    kk_std_os_dir_copy_directory(_uniq_x_10188, _x_x332, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x335 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_lift_copy_directory_10204_fun336(_uniq_xx_10189_0, to_3, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x335); return kk_Unit;
    }
    { // tailcall
      _uniq_xs_10185 = _uniq_xx_10189_0;
      goto kk__tailcall;
    }
  }
  {
    kk_std_os_path__path_drop(to_3, _ctx);
    kk_Unit; return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun340__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir_0;
  kk_std_os_path__path to_4;
};
static kk_box_t kk_std_os_dir_copy_directory_fun340(kk_function_t _fself, kk_box_t _b_x154, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun340(kk_std_os_path__path dir_0, kk_std_os_path__path to_4, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun340__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun340__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun340, kk_context());
  _self->dir_0 = dir_0;
  _self->to_4 = to_4;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun340(kk_function_t _fself, kk_box_t _b_x154, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun340__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun340__t*, _fself, _ctx);
  kk_std_os_path__path dir_0 = _self->dir_0; /* std/os/path/path */
  kk_std_os_path__path to_4 = _self->to_4; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir_0, _ctx);kk_std_os_path__path_dup(to_4, _ctx);}, {}, _ctx)
  kk_unit_t wild___1_169 = kk_Unit;
  kk_unit_unbox(_b_x154);
  kk_unit_t _x_x341 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10288(dir_0, to_4, wild___1_169, _ctx);
  return kk_unit_box(_x_x341);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun343__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun343(kk_function_t _fself, kk_box_t _b_x157, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun343(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun343, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun343(kk_function_t _fself, kk_box_t _b_x157, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _x_x344;
  kk_std_os_path__path _x_x345 = kk_std_os_path__path_unbox(_b_x157, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x344 = kk_std_os_dir_list_directory(_x_x345, _ctx); /*list<std/os/path/path>*/
  return kk_std_core_types__list_box(_x_x344, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun347__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_4;
};
static kk_box_t kk_std_os_dir_copy_directory_fun347(kk_function_t _fself, kk_box_t _b_x161, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun347(kk_std_os_path__path to_4, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun347__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun347__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun347, kk_context());
  _self->to_4 = to_4;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun347(kk_function_t _fself, kk_box_t _b_x161, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun347__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun347__t*, _fself, _ctx);
  kk_std_os_path__path to_4 = _self->to_4; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_4, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2 _y_x10236_1_170 = kk_std_core_types__tuple2_unbox(_b_x161, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x_x348 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10287(to_4, _y_x10236_1_170, _ctx);
  return kk_unit_box(_x_x348);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun351__t {
  struct kk_function_s _base;
  kk_std_core_types__list dirs_1;
  kk_std_os_path__path to_4;
};
static kk_box_t kk_std_os_dir_copy_directory_fun351(kk_function_t _fself, kk_box_t _b_x165, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun351(kk_std_core_types__list dirs_1, kk_std_os_path__path to_4, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun351__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun351__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun351, kk_context());
  _self->dirs_1 = dirs_1;
  _self->to_4 = to_4;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun351(kk_function_t _fself, kk_box_t _b_x165, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun351__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun351__t*, _fself, _ctx);
  kk_std_core_types__list dirs_1 = _self->dirs_1; /* list<std/os/path/path> */
  kk_std_os_path__path to_4 = _self->to_4; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core_types__list_dup(dirs_1, _ctx);kk_std_os_path__path_dup(to_4, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_1_171 = kk_Unit;
  kk_unit_unbox(_b_x165);
  kk_unit_t _x_x352 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10286(dirs_1, to_4, wild___0_1_171, _ctx);
  return kk_unit_box(_x_x352);
}

kk_unit_t kk_std_os_dir_copy_directory(kk_std_os_path__path dir_0, kk_std_os_path__path to_4, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path) -> <pure,fsys> () */ 
  kk_unit_t x_4_10336 = kk_Unit;
  kk_std_os_path__path _x_x338 = kk_std_os_path__path_dup(to_4, _ctx); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x_x338, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x339 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun340(dir_0, to_4, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x339); return kk_Unit;
  }
  {
    kk_std_core_types__list all_0;
    kk_box_t _x_x342 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun343(_ctx), kk_std_os_path__path_box(dir_0, _ctx), _ctx); /*9586*/
    all_0 = kk_std_core_types__list_unbox(_x_x342, KK_OWNED, _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__tuple2 x_5_10339 = kk_std_os_dir__lift_copy_directory_10200(all_0, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
    if (kk_yielding(kk_context())) {
      kk_std_core_types__tuple2_drop(x_5_10339, _ctx);
      kk_box_t _x_x346 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun347(to_4, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x346); return kk_Unit;
    }
    {
      kk_box_t _box_x162 = x_5_10339.fst;
      kk_box_t _box_x163 = x_5_10339.snd;
      kk_std_core_types__list dirs_1 = kk_std_core_types__list_unbox(_box_x162, KK_BORROWED, _ctx);
      kk_std_core_types__list files_0 = kk_std_core_types__list_unbox(_box_x163, KK_BORROWED, _ctx);
      kk_std_core_types__list_dup(dirs_1, _ctx);
      kk_std_core_types__list_dup(files_0, _ctx);
      kk_std_core_types__tuple2_drop(x_5_10339, _ctx);
      kk_unit_t x_6_10342 = kk_Unit;
      kk_std_os_path__path _x_x349 = kk_std_os_path__path_dup(to_4, _ctx); /*std/os/path/path*/
      kk_std_os_dir__lift_copy_directory_10201(_x_x349, files_0, _ctx);
      if (kk_yielding(kk_context())) {
        kk_box_t _x_x350 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun351(dirs_1, to_4, _ctx), _ctx); /*2401*/
        kk_unit_unbox(_x_x350); return kk_Unit;
      }
      {
        kk_std_os_dir__lift_copy_directory_10203(to_4, dirs_1, _ctx); return kk_Unit;
      }
    }
  }
}
 
// Copy a file to a directory

kk_unit_t kk_std_os_dir_copy_file_to_dir(kk_std_os_path__path from, kk_std_os_path__path dir, kk_context_t* _ctx) { /* (from : std/os/path/path, dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
  kk_std_core_types__list _b_x172_173;
  kk_std_core_types__list _x_x353;
  {
    kk_std_core_types__list _x_1_1 = from.parts;
    kk_std_core_types__list_dup(_x_1_1, _ctx);
    _x_x353 = _x_1_1; /*list<string>*/
  }
  _b_x172_173 = kk_std_core_list_take(_x_x353, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  kk_evv_t w_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
  kk_std_os_path__path p2;
  kk_string_t _x_x354 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x356;
  kk_std_core_types__optional _match_x179 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x172_173, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x179, _ctx)) {
    kk_box_t _box_x174 = _match_x179._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_133 = kk_std_core_types__list_unbox(_box_x174, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_133, _ctx);
    kk_std_core_types__optional_drop(_match_x179, _ctx);
    _x_x356 = _uniq_parts_133; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x179, _ctx);
    {
      kk_std_core_types__list _x_0_1 = from.parts;
      kk_std_core_types__list_dup(_x_0_1, _ctx);
      _x_x356 = _x_0_1; /*list<string>*/
    }
  }
  p2 = kk_std_os_path__new_Path(_x_x354, _x_x356, _ctx); /*std/os/path/path*/
  kk_std_core_types__list parts_0_10093;
  {
    kk_std_core_types__list _x_0 = p2.parts;
    kk_std_core_types__list_dup(_x_0, _ctx);
    if (kk_std_core_types__is_Nil(_x_0, _ctx)) {
      kk_std_os_path__path_drop(p2, _ctx);
      parts_0_10093 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
    }
    else {
      kk_std_core_types__list_drop(_x_0, _ctx);
      kk_std_core_types__list _x_x357;
      {
        kk_std_core_types__list _x_0_0 = p2.parts;
        kk_std_core_types__list_dup(_x_0_0, _ctx);
        kk_std_os_path__path_drop(p2, _ctx);
        _x_x357 = _x_0_0; /*list<string>*/
      }
      parts_0_10093 = kk_std_core_list__unroll_reverse_acc_10003(kk_std_core_types__new_Nil(_ctx), _x_x357, _ctx); /*list<string>*/
    }
  }
  kk_std_core_types__list _b_x175_176;
  if (kk_std_core_types__is_Nil(parts_0_10093, _ctx)) {
    kk_std_core_types__list _x_1 = dir.parts;
    kk_std_core_types__list_dup(_x_1, _ctx);
    _b_x175_176 = _x_1; /*list<string>*/
  }
  else {
    kk_std_core_types__list _x_x358;
    {
      kk_std_core_types__list _x_1_0 = dir.parts;
      kk_std_core_types__list_dup(_x_1_0, _ctx);
      _x_x358 = _x_1_0; /*list<string>*/
    }
    _b_x175_176 = kk_std_os_path__unroll_push_parts_10000(parts_0_10093, _x_x358, _ctx); /*list<string>*/
  }
  kk_unit_t keep_0 = kk_Unit;
  kk_evv_set(w_0,kk_context());
  kk_std_os_path__path _x_x359;
  kk_string_t _x_x360;
  {
    kk_string_t _x = dir.root;
    kk_string_dup(_x, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    _x_x360 = _x; /*string*/
  }
  kk_std_core_types__list _x_x361;
  kk_std_core_types__optional _match_x178 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x175_176, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x178, _ctx)) {
    kk_box_t _box_x177 = _match_x178._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_95 = kk_std_core_types__list_unbox(_box_x177, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_95, _ctx);
    kk_std_core_types__optional_drop(_match_x178, _ctx);
    _x_x361 = _uniq_parts_95; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x178, _ctx);
    _x_x361 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
  }
  _x_x359 = kk_std_os_path__new_Path(_x_x360, _x_x361, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(from, _x_x359, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}

bool kk_std_os_dir_prim_is_file(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys bool */ 
  return kk_os_is_file(path,kk_context());
}

// initialization
void kk_std_os_dir__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_bool__init(_ctx);
  kk_std_core_order__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_sslice__init(_ctx);
  kk_std_core_list__init(_ctx);
  kk_std_core_maybe__init(_ctx);
  kk_std_core_maybe2__init(_ctx);
  kk_std_core_either__init(_ctx);
  kk_std_core_tuple__init(_ctx);
  kk_std_core_lazy__init(_ctx);
  kk_std_core_show__init(_ctx);
  kk_std_core_debug__init(_ctx);
  kk_std_core_delayed__init(_ctx);
  kk_std_core_console__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_dir__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_console__done(_ctx);
  kk_std_core_delayed__done(_ctx);
  kk_std_core_debug__done(_ctx);
  kk_std_core_show__done(_ctx);
  kk_std_core_lazy__done(_ctx);
  kk_std_core_tuple__done(_ctx);
  kk_std_core_either__done(_ctx);
  kk_std_core_maybe2__done(_ctx);
  kk_std_core_maybe__done(_ctx);
  kk_std_core_list__done(_ctx);
  kk_std_core_sslice__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_order__done(_ctx);
  kk_std_core_bool__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
